%{
#define YY_INPUT(buf,result,max_size) {\
   int size = max_size < src.size ? max_size : src.size;\
   if (src.size == 0)\
      result = YY_NULL;\
   else {\
      memcpy(buf, src.b + src.pos, size);\
      src.pos += size;\
      src.size -= size;\
      result = size;\
   }\
}

void str2upper(string &sbuf) {
   for (int i = 0; i < sbuf.length(); i++)
      sbuf[i] = toupper(sbuf[i]);
}
void lexaddsym(const string& sbuf, int len = 2) {
   if (names.find(sbuf) == names.end()) {
      if (sbuf[sbuf.length() - 1] == '$') {
         names[sbuf].type = SVAR;
         names[sbuf].addr = svarp;
         names[sbuf].len = len;
         svarp += len;
      }
      else if (sbuf[sbuf.length() - 1] == '%') {
         names[sbuf].type = IVAR;
         names[sbuf].addr = ivarp;
         names[sbuf].len = len;
         ivarp += len;
      }
      else {
         names[sbuf].type = RVAR;
         names[sbuf].addr = rvarp;
         names[sbuf].len = 3*(len/2);
         rvarp += 3*(len/2);
      }
      names[sbuf].name = &(string&)names.find(sbuf)->first;
   }
}
int lexeol = 1, insgoto;
string curdeffn;
%}
%option    noyywrap
number	   ([0-9]+[ ]*[0-9]+)+|[0-9]+
mantissa   {number}?\.{number}|{number}\.{number}?
real       {number}[eE][-+]?{number}|{mantissa}([eE][-+]?{number})?
symbol     [a-zA-Z][a-zA-Z0-9]*(\$|\%)?
string     \"[^"]*\"
space      [ \t]+
datastr    [^,:\n]*
dataelem   {space}*({string}|{datastr})
dataline   (?i:DATA)({dataelem},)*{dataelem}
%%
{space}
(?i:REM).*
~          return PI;
>=	   return GE;
=>	   return GE;
\<= 	   return LE;
=\< 	   return LE;
\<> 	   return NE;
>\< 	   return NE;
> 	   return GT;
\< 	   return LT;
\?         return PRINT;
(?i:ABS)   return ABS;
(?i:AND)   return AND;
(?i:ASC)   return ASC;
(?i:ATN)   return ATN;
(?i:CHAR)  return CHAR;
(?i:CHR)\$ return CHR;
(?i:CLR)   return CLR;
(?i:CLOSE) return CLOSE;
(?i:CMD)   return CMD;
(?i:COLOR) return COLOR;
(?i:COLLECT) return COLLECT;
(?i:COPY)  return COPY;
(?i:DEC)   return DEC;
(?i:DEF)   return DEF;
(?i:DIM)   return DIM;
(?i:DIRECTORY)  return DIRECTORY;
(?i:DO)    yylval.num = progp; return DO;
(?i:ELSE){space}*{number}  yylval.num = progp; elsec++; elset++; yyless(4); insgoto = 1; return ELSE;
(?i:ELSE)  yylval.num = progp; elsec++; elset++; return ELSE;
(?i:END)   return END;
(?i:EXIT)  return EXIT;
(?i:EXP)   return EXP;
(?i:FN)    return FN;
(?i:FOR)   yylval.num = progp; return FOR;
(?i:FRE){space}*\([^)]+\)  return FRE;
(?i:GET)   return GET;
(?i:GETKEY) return GETKEY;
(?i:GO){space}(?:TO) return GOTO;
(?i:GOSUB) return GOSUB;
(?i:GOTO)  if (iff == 1) return iff = 0, insgoto = 1, THEN; else return GOTO;
(?i:HEADER) return HEADER;
(?i:HEX)\$ return HEX;
(?i:IF)    yylval.num = progp; elsec = 0; iff = 1; return IF;
(?i:INPUT) return INPUT;
(?i:INSTR) return INSTR;
(?i:INT)   return INT;
(?i:JOY)   return JOY;
(?i:KEY)   return KEY;
(?i:LEN)   return LEN;
(?i:LEFT)\$ return LEFT;
(?i:LET)   return LET;
(?i:LOAD)  return LOAD;
(?i:LOG)   return LOG;
(?i:LOOP)  return LOOP;
(?i:LOCATE) return LOCATE;
(?i:MID)\$ return MID;
(?i:MONITOR) return MONITOR;
(?i:NEXT){space}*{symbol}(\([^)]+\))*,  unput('T'); unput('X'); unput('E'); unput('N');unput(':'); return NEXT;
(?i:NEXT){space}*{symbol}(\([^)]+\))*  return NEXT;
(?i:NEXT)  return NEXT;
(?i:NEW)   return NEW;
(?i:NOT)   return NOT;
(?i:ON)    return ON;
(?i:OPEN)  return OPEN;
(?i:OR)    return OR;
(?i:PEEK)  return PEEK;
(?i:POKE)  return POKE;
(?i:POS){space}*\(.+\) return POS;
(?i:PRINT) return PRINT;
(?i:PUDEF) return PUDEF;
(?i:RCLR)  return RCLR;
(?i:RDOT)  return RDOT;
(?i:READ)  return READ;
(?i:RENAME) return RENAME;
(?i:RETURN) return RETURN;
(?i:RESTORE) return RESTORE;
(?i:RGR){space}*\([^)]+\) return RGR;
(?i:RIGHT)\$ return RIGHT;
(?i:RLUM)  return RLUM;
(?i:RUN)   return RUN;
blocked(?i:SAVE)  return SAVE;
(?i:SCNCLR) return SCNCLR;
(?i:SCRATCH) return SCRATCH;
(?i:SGN)   return SGN;
(?i:SOUND) return SOUND;
(?i:SPC)   return SPC;
(?i:SQR)   return SQR;
(?i:STEP)  return STEP;
(?i:STR)\$ return STR;
(?i:SYS)   return SYS;
(?i:TAB)   return TAB;
(?i:THEN){space}*{number}  iff = 0; yyless(4); insgoto = 1; return THEN;
(?i:THEN)  iff = 0; return THEN;
(?i:TO)    return TO;
(?i:TRAP)  return TRAP;
(?i:UNTIL) yylval.num = 0;return WHILE_UNTIL;
(?i:USING) return USING;
(?i:USR)   return USR;
(?i:VAL)   return VAL;
(?i:VERIFY) return VERIFY;
(?i:VOL)   return VOL;
(?i:WAIT)  return WAIT;
(?i:WHILE) yylval.num = 1;return WHILE_UNTIL;
(u|U){space}?{number} {
              if (!ucontext) REJECT;
              string sbuf(yytext + 1);
              istringstream iss(sbuf);
              iss >> yylval.num;
              return Unum;
}
(d|D){space}?{number} {
              if (!ucontext) REJECT;
              string sbuf(yytext + 1);
              istringstream iss(sbuf);
              iss >> yylval.num;
              return Dnum;
}
(i|I).. {
              if (!ucontext) REJECT;
              yylval.num = ((unsigned)toupper(yytext[1]))*256 + (unsigned)toupper(yytext[2]);
              return Iid;
}
{number}   {
              if (insgoto) {
                 yyless(0);
                 insgoto = 0;
                 return GOTO;
              }
              string sbuf(yytext);
              istringstream iss(sbuf);
              iss >> yylval.num;
              if (lexeol) {
                 lexeol = 0;
                 if (yylval.num < 64000)
                    return LABEL;
                 throw "line number is too big";
              }
              else if (yylval.num < (1 << 15) - 1)
                 return NUMBER;
              else
                 return REAL;
           }
{real}   {
              string sbuf(yytext);
              istringstream iss(sbuf);
              iss >> yylval.real;
              yylval.num = rint(yylval.real);
              return REAL;
           }
\.       {
              yylval.num = 0;
              return REAL;
         }
{symbol}   {
              string sbuf(yytext);
              str2upper(sbuf);
              int ls = sbuf.length();
              char lc = sbuf[ls - 1];
              if ((lc == '%' || lc == '$') && ls > 3)
                 sbuf = sbuf.substr(0, 2) + lc;
              else if (ls > 2 && lc != '%' && lc != '$')
                 sbuf = sbuf.substr(0, 2);
              if (sbuf == "TI") return TI;
              if (sbuf == "ST") return ST;
              if (sbuf == "TI$") return TIs;
              if (sbuf == "U" && ucontext) return U;
              if (sbuf == "D" && ucontext) return D;
              if (sbuf == "DS") {
                 if (names.find("DS$") == names.end()) {
                    names[sbuf].type = SVAR;
                    names[sbuf].len = 2;
                 }
                 return DS;
              }
              if (sbuf == "DS$") {
                 if (names.find(sbuf) == names.end()) {
                    names[sbuf].type = SVAR;
                    names[sbuf].len = 2;
                 }
                 return DSs;
              }
              if (deffn == 0) {
                 curdeffn = sbuf;
                 sbuf = ":" + sbuf;
                 deffn++;
                 lexaddsym(sbuf, 0);
                 if (names[sbuf].type == SVAR || names[sbuf].type == IVAR)
                    throw "CBM Basic doesn't allow string or integer FN";
                 else
                    names[sbuf].type = RFN;
              }
              else if (deffn > 0) {
                 sbuf = curdeffn + ":" + sbuf;
                 lexaddsym(sbuf, 0);
                 names[sbuf].addr = deffn++;
                 if (names[sbuf].type == SVAR || names[sbuf].type == IVAR)
                    throw "CBM Basic doesn't allow string or integer parameter for FN";
                 else
                    names[sbuf].type = FVAR;
              }
              else if (deffn == -2) {
                 if (names.find(curdeffn + ":" + sbuf) != names.end())
                    sbuf = curdeffn + ":" + sbuf;
              }
              if (deffn < 0)
                 if (callfn == 0)
                    if (names.find(":" + sbuf) != names.end())
                       callfn++, sbuf = ":" + sbuf;
                    else
                       throw (string) "call to undefined function";
                 else
                    lexaddsym(sbuf);
              yylval.sym = &names[sbuf];
              return yylval.sym->type;
           }
{string}   {
              string istr(yytext + 1);
              istr.erase(istr.length() - 1);
              if (istr.length() == 0)
                  strings[istr].len = 0;
              else
                  lexre(istr);
              if (strings.find(istr) == strings.end()) {
                  strings[istr].addr = strconstp;
                  strconstp += (strings[istr].len = istr.length()) + 1;
                  strings[istr].name = &(string&)strings.find(istr)->first;
                  strings[istr].used = 0;
              }
              yylval.sym = &strings[istr];
              return yylval.sym->type = STRINGTYPE;
           }
{dataline} {
              yylval.sym = (Symbol*)(yytext + 4);
              return DATAOPER;
           }
\n	   ++lineno; lexeol = 1;
.          return yytext[0];

