%{
#include <cctype>
#include "cbm35basic.h"
#define SRCMAX 200000
map<int, Symbol*> realloca, reallocs;
map<string, Symbol> names, strings;
map<int, int> reallocl, labels, datalabels, dataprogp;
map<string,int> used_code;
int datalines_count, dataline, dataoffset, fnep, deffn = -1, iff, elsec, callfn = -1,
   elset, ifa[20], elsea[20], ifc, dolevel, dostore[200], ucontext, dimcount;
string code[100000], data1[100000], datalines[10000];
struct SRC {
   char b[SRCMAX];
   int size, pos, cpos, ocpos;
} src;
vector<unsigned> v;
void syntax1(Symbol*), syntax2(Symbol*), syntax3(Symbol*), syntax4(Symbol*);
Symbol *ptempsymb;
%}
%union {
  Symbol *sym;
  int num;
  double real;
}
%token <sym> SVAR IVAR RVAR FVAR RFN STRINGTYPE DATAOPER
//%token <real> REAL
%token <num> NUMBER REAL U Unum D Dnum Iid
%token <num> ASC SCNCLR ELSE FRE GOSUB GOTO LEN PRINT NEXT TO INT
%token <num> FOR IF INPUT LOCATE PEEK POKE RETURN STEP VAL THEN POS END
%token <num> CLOSE OPEN DIRECTORY GET LET ABS SGN FN DO LEFT RIGHT ST
%token <num> ON STR CHR GETKEY MID HEX CLR LOAD SAVE DEF USR CMD
%token <num> SPC TAB READ RESTORE DEC INSTR LABEL CHAR RUN NEW TI TIs TRAP
%token <num> DIM COLOR MONITOR SYS WAIT WHILE_UNTIL EXIT LOOP USING DS DSs
%token <num> VOL SOUND RCLR RLUM RDOT RGR SCRATCH COPY COLLECT RENAME HEADER
%token <num> VERIFY JOY KEY PUDEF LOG EXP SQR PI ATN
%type <num> dimenlist disc_command3 disc_command3d disc_command4
%left OR
%left AND
%left '=' GT GE LT LE NE
%left '+' '-'
%left '*' '/'
%left '^'
%left NOT
%%
prog: linenumber operlist {
   cerr << endl;  //finishes translated line numbers
}
;
operlist: oper
| oper operend operlist
;
linenumber: LABEL {
    if (comm_on) code[progp++] = ";" + comments();
    cerr << $1 << " "; //shows translated line numbers
    code[progp++] = "__" + tostry(locals);
    labels[dataline = $1] = locals++;
}
;
operend: linenumber {elset = ifc = iff = 0;}
| ':'
;
oper:
| LET assign
| assign
| print
| for
| if
| do
| exit
| sys
| char
| open
| load
| save
| sound
| verify
| def fnihead fnibody
| DIM arraylist
| DATAOPER {
    char *p, *q;
    string istr((char*)$1);
    if (datalabels.find(dataline) == datalabels.end()) datalabels[dataline] = dataoffset;
    lexre(istr);
    p = (char*)istr.c_str();
    for (;;) {
       while (*p == ' ' || *p == '\t') p++;
       if (*p == '"') {
          q = strchr(++p, '"');
          dataoffset += q - p + 1;
          datalines[datalines_count++].assign(p, q - p);
          p = q + 1;
          while (*p == ' ' || *p == '\t') p++;
          if (*p == 0)
              break;
          else if (*p != ',')
              throw (string) "wrong DATA line";
          else
              p++;
       }
       else
          if (q = strchr(p, ',')) {
             dataoffset += q - p + 1;
             datalines[datalines_count++].assign(p, q - p);
             p = q + 1;
          }
          else {
             dataoffset += strlen(p) + 1;
             datalines[datalines_count++] = p;
             break;
          }
    }
}
| RESTORE {
     code[progp++] = "LDA #>datastart\nSTA datapos+1\nLDA #<datastart\nSTA datapos\n";
}
| RESTORE NUMBER {
     dataprogp[progp++] = $2;
}
| CLOSE iexpr {
     used_code["close"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nJSR close\n";
}
| CLOSE rexpr {
     used_code["close"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nJSR close\n";
}
| CMD ofexpr
| GOSUB NUMBER {
     code[progp++] = "JSR ";
     reallocl[progp++] = $2;
}
| RETURN {code[progp++] = "RTS\n";}
| GOTO NUMBER {
      code[progp++] = "JMP ";
      reallocl[progp++] = $2;
}
| TRAP NUMBER {
      code[progp++] = "LDA #<";
      reallocl[progp++] = $2;
      code[progp++] = "STA traphandle0+1\n";
      code[progp++] = "LDA #>";
      reallocl[progp++] = $2;
      code[progp++] = "STA traphandle0+2\n";
}
| TRAP {
      code[progp++] = "LDA #<default_rte\n";
      code[progp++] = "STA traphandle0+1\n";
      code[progp++] = "LDA #>default_rte\n";
      code[progp++] = "STA traphandle0+2\n";
}
| RUN {
      code[progp++] = "JMP progstart0";
}
| RUN NUMBER {
      code[progp++] = "JSR clr\nJMP ";
      reallocl[progp++] = $2;
}
| ON iexpr GOTO {
      code[progp++] = "__" + tostry(locals + 1);
      code[progp++] = "JMP __" + tostry(locals);
} labellist {
      code[progp++] = "__" + tostry(locals);
      code[progp++] = "PLA\nASL\nSTA r2l\nPLA\n";
      //code[progp++] = "BMI __" + tostry(locals + 2);  //run-time error
      code[progp++] = "ROL\nBNE __" + tostry(locals + 2);
      code[progp++] = "ORA r2l\n";
      code[progp++] = "BEQ __" + tostry(locals + 2);
      code[progp++] = "CMP #<__" + tostr(locals) + "-2-__" + tostry(locals + 1);
      code[progp++] = "BCS __" + tostry(locals + 2);
      code[progp++] = "TAY\nLDA __" + tostr(locals + 1) + "+1,Y\n";
      code[progp++] = "STA r2l\n";
      code[progp++] = "LDA __" + tostr(locals + 1) + "+2,Y\n";
      code[progp++] = "STA r2h\n";
      code[progp++] = "JMP (r2l)\n";
      code[progp++] = "__" + tostry(locals + 2);
      locals += 3;
}
| ON rexpr GOTO {
      code[progp++] = "__" + tostry(locals + 1);
      code[progp++] = "JMP __" + tostry(locals);
} labellist {
      code[progp++] = "__" + tostry(locals);
      code[progp++] = "PLA\nASL\nTAX\nPLA\nPLA\n";
      //code[progp++] = "BMI __" + tostry(locals + 2);  //run-time error
      code[progp++] = "TXA\n";
      code[progp++] = "BEQ __" + tostry(locals + 2);
      code[progp++] = "CMP #<__" + tostr(locals) + "-2-__" + tostry(locals + 1);
      code[progp++] = "BCS __" + tostry(locals + 2);
      code[progp++] = "TAY\nLDA __" + tostr(locals + 1) + "+1,Y\n";
      code[progp++] = "STA r2l\n";
      code[progp++] = "LDA __" + tostr(locals + 1) + "+2,Y\n";
      code[progp++] = "STA r2h\n";
      code[progp++] = "JMP (r2l)\n";
      code[progp++] = "__" + tostry(locals + 2);
      locals += 3;
}
| ON iexpr GOSUB {
      code[progp++] = "__" + tostry(locals + 1);
      code[progp++] = "JMP __" + tostry(locals);
} labellist {
      code[progp++] = "__" + tostry(locals);
      code[progp++] = "PLA\nASL\nSTA r2l\nPLA\n";
      //code[progp++] = "BNE __" + tostry(locals + 2);  //run-time error
      code[progp++] = "ROL\nBNE __" + tostry(locals + 2);
      code[progp++] = "ORA r2l\n";
      code[progp++] = "BEQ __" + tostry(locals + 2);
      code[progp++] = "CMP #<__" + tostr(locals) + "-2-__" + tostry(locals + 1);
      code[progp++] = "BCS __" + tostry(locals + 2);
      code[progp++] = "TAY\nLDA __" + tostr(locals + 1) + "+1,Y\n";
      code[progp++] = "STA *+10\n";
      code[progp++] = "LDA __" + tostr(locals + 1) + "+2,Y\n";
      code[progp++] = "STA *+5\n";
      code[progp++] = "JSR 2000\n";
      code[progp++] = "__" + tostry(locals + 2);
      locals += 3;
}
| ON rexpr GOSUB {
      code[progp++] = "__" + tostry(locals + 1);
      code[progp++] = "JMP __" + tostry(locals);
} labellist {
      code[progp++] = "__" + tostry(locals);
      code[progp++] = "PLA\nASL\nTAX\nPLA\nPLA\n";
      //code[progp++] = "BMI __" + tostry(locals + 2);  //run-time error
      code[progp++] = "TXA\n";
      code[progp++] = "BEQ __" + tostry(locals + 2);
      code[progp++] = "CMP #<__" + tostr(locals) + "-2-__" + tostry(locals + 1);
      code[progp++] = "BCS __" + tostry(locals + 2);
      code[progp++] = "TAY\nLDA __" + tostr(locals + 1) + "+1,Y\n";
      code[progp++] = "STA *+10\n";
      code[progp++] = "LDA __" + tostr(locals + 1) + "+2,Y\n";
      code[progp++] = "STA *+5\n";
      code[progp++] = "JSR 2000\n";
      code[progp++] = "__" + tostry(locals + 2);
      locals += 3;
}
| SCNCLR {code[progp++] = "LDA #147\nJSR coutROM\n";} //graph
| CLR {code[progp++] = "JSR clr\n";}
| input
| READ varlistd
| GET '#' ifexpr ',' getfvar endio
| GET getvar
| NEW {code[progp++] = "LDA #0\nSTA r5l\nLDA #$80\nSTA r5h\nJMP ROMcall\n";}
| POKE iexpr ',' iexpr {code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA *+8\nPLA\nSTA *+5\nSTX 1000\n";}
| POKE iexpr ',' rexpr {code[progp++] = "PLA\nTAX\nPLA\nPLA\nPLA\nSTA *+8\nPLA\nSTA *+5\nSTX 1000\n";}
| POKE rexpr ',' iexpr {code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA *+9\nPLA\nSTA *+6\nPLA\nSTX 1000\n";}
| POKE rexpr ',' rexpr {code[progp++] = "PLA\nTAX\nPLA\nPLA\nPLA\nSTA *+9\nPLA\nSTA *+6\nPLA\nSTX 1000\n";}
| WAIT iexpr ',' iexpr {
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nLDY #0\nTXA\nAND (r5l),Y\nBEQ *-3\n";
}
| WAIT iexpr ',' rexpr {
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nLDY #0\nTXA\nAND (r5l),Y\nBEQ *-3\n";
}
| WAIT rexpr ',' iexpr {
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nPLA\nLDY #0\nTXA\nAND (r5l),Y\nBEQ *-3\n";
}
| WAIT rexpr ',' rexpr {
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nPLA\nLDY #0\nTXA\nAND (r5l),Y\nBEQ *-3\n";
}
| WAIT iexpr ',' iexpr ',' iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nPLA\nSTA r2h\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nLDY #0\nLDA (r5l),Y\nEOR r2h\nBIT r2l\nBEQ *-6\n";
}
| WAIT rexpr ',' iexpr ',' iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nPLA\nSTA r2h\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nPLA\nLDY #0\nLDA (r5l),Y\nEOR r2h\nBIT r2l\nBEQ *-6\n";
}
| WAIT iexpr ',' rexpr ',' iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nPLA\nSTA r2h\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nLDY #0\nLDA (r5l),Y\nEOR r2h\nBIT r2l\nBEQ *-6\n";
}
| WAIT rexpr ',' rexpr ',' iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nPLA\nSTA r2h\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nPLA\nLDY #0\nLDA (r5l),Y\nEOR r2h\nBIT r2l\nBEQ *-6\n";
}
| WAIT iexpr ',' iexpr ',' rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nPLA\nPLA\nSTA r2h\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nLDY #0\nLDA (r5l),Y\nEOR r2h\nBIT r2l\nBEQ *-6\n";
}
| WAIT rexpr ',' iexpr ',' rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nPLA\nPLA\nSTA r2h\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nPLA\nLDY #0\nLDA (r5l),Y\nEOR r2h\nBIT r2l\nBEQ *-6\n";
}
| WAIT iexpr ',' rexpr ',' rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nPLA\nPLA\nSTA r2h\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nLDY #0\nLDA (r5l),Y\nEOR r2h\nBIT r2l\nBEQ *-6\n";
}
| WAIT rexpr ',' rexpr ',' rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nPLA\nPLA\nSTA r2h\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nSTA r5h\nPLA\nLDY #0\nLDA (r5l),Y\nEOR r2h\nBIT r2l\nBEQ *-6\n";
}
| COLOR iexpr ',' iexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nSTA r5l\nPLA\nPLA\nTAX\nPLA\nLDY #7\nJSR color\n";
}
| COLOR iexpr ',' rexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nSTA r5l\nPLA\nPLA\nPLA\nTAX\nPLA\nLDY #7\nJSR color\n";
}
| COLOR rexpr ',' iexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nSTA r5l\nPLA\nPLA\nTAX\nPLA\nPLA\nLDY #7\nJSR color\n";
}
| COLOR rexpr ',' rexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nSTA r5l\nPLA\nPLA\nPLA\nTAX\nPLA\nPLA\nLDY #7\nJSR color\n";
}
| COLOR iexpr ',' iexpr ',' iexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nSTA r5l\nPLA\nPLA\nTAX\nPLA\nJSR color\n";
}
| COLOR iexpr ',' iexpr ',' rexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nPLA\nTAX\nPLA\nJSR color\n";
}
| COLOR iexpr ',' rexpr ',' iexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nSTA r5l\nPLA\nPLA\nPLA\nTAX\nPLA\nJSR color\n";
}
| COLOR iexpr ',' rexpr ',' rexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nPLA\nPLA\nTAX\nPLA\nJSR color\n";
}
| COLOR rexpr ',' iexpr ',' iexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nSTA r5l\nPLA\nPLA\nTAX\nPLA\nPLA\nJSR color\n";
}
| COLOR rexpr ',' iexpr ',' rexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nPLA\nTAX\nPLA\nPLA\nJSR color\n";
}
| COLOR rexpr ',' rexpr ',' iexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nSTA r5l\nPLA\nPLA\nPLA\nTAX\nPLA\nPLA\nJSR color\n";
}
| COLOR rexpr ',' rexpr ',' rexpr {
     used_code["color"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nPLA\nSTA r5l\nPLA\nPLA\nPLA\nTAX\nPLA\nPLA\nJSR color\n";
}
| END {code[progp++] = "JMP finalfinish\n";}
| GETKEY ivar {
     used_code["getkey_I0"] = 1;
     code[progp++] = "PLA\nSTA r0l\nPLA\nSTA r0h\nLDA #<GETIN\nSTA r5l\nLDA #>GETIN\nSTA r5h\nJSR ROMcall\nTAY\nBEQ *-4\n";
     code[progp++] = "JSR getkeyint0\n";
}
| GETKEY rvar {
     used_code["getkey_I0"] = 1;
     code[progp++] = "PLA\nSTA r0l\nPLA\nSTA r0h\nLDA #<GETIN\nSTA r5l\nLDA #>GETIN\nSTA r5h\nJSR ROMcall\nTAY\nBEQ *-4\n";
     code[progp++] = "JSR getkeyint0\nINY\nSTA (r0l),Y\n";
}
| GETKEY svar {
     used_code["getkey_S"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r4l\nPLA\nJSR getkey1\n";
}
| PUDEF sexpr {
     used_code["pudef"] = 1;
     code[progp++] = "PLA\nSTA r4l\nPLA\nJSR pudef\n";
}
| MONITOR {code[progp++] = "LDA #$45\nSTA r5l\nLDA #$f4\nSTA r5h\nJMP ROMcall\n";}
| VOL e1iexpr {code[progp++] = "PLA\nSTA r2l\nPLA\nLDA $FF11\nAND #$F0\nORA r2l\nSTA $FF11\n";}
| KEY e1iexpr ',' sexpr {
     used_code["key"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\nJSR key\n";
}
| KEY {
     code[progp++] = "LDA #$2B\nSTA r5l\nLDA #$B7\nSTA r5h\nJSR ROMcall\n";
}
| COLLECT {ucontext = 1;} disc_command2 {
     used_code["collect"] = 1;
     ucontext = 0;
     code[progp++] = "PLA\nTAX\nPLA\nJSR collect\n";
}
| SCRATCH {ucontext = 1;} disc_command3 {
     used_code["scratch"] = 1;
     ucontext = 0;
     switch ($3) {
        case 0: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDX #8\nJSR scratch\n"; break;
        case 1: code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR scratch\n"; break;
        case 2: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\nJSR scratch\n";
     }
}
| COPY {ucontext = 1;} disc_command3 TO disc_command3 {
     used_code["copy"] = 1;
     ucontext = 0;
     switch ($5) {
        case 0: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDX #0\n"; break;
        case 1: code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\n"; break;
        case 2: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\n";
     }
     code[progp++] = "LDA #$43\nSTA r4l\n"; //"C"
     switch ($3) {
        case 0: code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nLDY #0\nJSR copy\n"; break;
        case 1: code[progp++] = "PLA\nTAY\nPLA\nPLA\nSTA r3l\nPLA\nSTA r3h\nJSR copy\n"; break;
        case 2: code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nTAY\nPLA\nJSR copy\n";
     }
}
| RENAME {ucontext = 1;} disc_command3 TO disc_command3 {
     used_code["copy"] = 1;
     ucontext = 0;
     switch ($5) {
        case 0: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDX #0\n"; break;
        case 1: code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\n"; break;
        case 2: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\n";
     }
     code[progp++] = "LDA #$52\nSTA r4l\n"; //"R"
     switch ($3) {
        case 0: code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nLDY #0\nJSR copy\n"; break;
        case 1: code[progp++] = "PLA\nTAY\nPLA\nPLA\nSTA r3l\nPLA\nSTA r3h\nJSR copy\n"; break;
        case 2: code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nTAY\nPLA\nJSR copy\n";
     }
}
| DIRECTORY {ucontext = 1;} disc_command3d {
     used_code["cat"] = 1;
     ucontext = 0;
     switch ($3) {
        case 0: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDX #0\nJSR cat\n"; break;
        case 1: code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR cat\n"; break;
        case 2: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\nJSR cat\n"; break;
        case 3: code[progp++] = "LDX #0\nSTX r2h\nJSR cat\n"; break;
        case 4: code[progp++] = "LDA #0\nSTA r2h\nPLA\nTAX\nPLA\nJSR cat\n";
     }
}
| HEADER {ucontext = 1;} disc_command4 {
     used_code["header"] = 1;
     ucontext = 0;
     switch ($3) {
        case 0: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDX #8\nLDA #0\nSTA r3h\nJSR header\n"; break;
        case 1: code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nLDA #0\nSTA r3h\nJSR header\n"; break;
        case 2: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\nLDA #0\nSTA r3h\nJSR header\n"; break;
        case 3: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nLDX #8\nJSR header\n"; break;
        case 4: code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r2l\nPLA\nSTA r2h\nLDX #8\nJSR header\n"; break;
        case 5: code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nJSR header\n"; break;
        case 6: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\nPLA\nSTA r3l\nPLA\nSTA r3h\nJSR header\n"; break;
        case 7: code[progp++] = "PLA\nTAX\nPLA\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR header\n"; break;
        case 8: code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nTAX\nPLA\nJSR header\n"; break;
        case 9: code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nTAX\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR header\n"; break;
        case 10: code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\nJSR header\n";
     }
}
;
disc_command2: {code[progp++] = "LDA #0\nPHA\nLDA #8\nPHA\n";}
| unit ',' disk
| disk ',' unit
| disk
| unit
;
disc_command4: ucname ',' disk {$$ = 0;}
| disk ',' ucname {$$ = 0;}
| ucname ',' unit ',' disk {$$ = 1;}
| ucname ',' disk ',' unit {$$ = 1;}
| disk ',' unit ',' ucname {$$ = 2;}
| disk ',' ucname ',' unit {$$ = 1;}
| unit ',' disk ',' ucname {$$ = 2;}
| unit ',' ucname ',' disk {$$ = 2;}
| ucname ',' disk ',' disk_id {$$ = 3;}
| ucname ',' disk_id ',' disk {$$ = 3;}
| disk ',' ucname ',' disk_id {$$ = 3;}
| disk_id ',' ucname ',' disk {$$ = 4;}
| disk ',' disk_id ',' ucname {$$ = 4;}
| disk_id ',' disk ',' ucname {$$ = 4;}
| disk_id ',' ucname ',' unit ',' disk {$$ = 5;}
| disk_id ',' ucname ',' disk ',' unit {$$ = 5;}
| disk_id ',' disk ',' unit ',' ucname {$$ = 6;}
| disk_id ',' disk ',' ucname ',' unit {$$ = 5;}
| disk_id ',' unit ',' disk ',' ucname {$$ = 6;}
| disk_id ',' unit ',' ucname ',' disk {$$ = 6;}
| ucname ',' disk_id ',' unit ',' disk {$$ = 7;}
| ucname ',' disk_id ',' disk ',' unit {$$ = 7;}
| disk ',' disk_id ',' unit ',' ucname {$$ = 6;}
| disk ',' disk_id ',' ucname ',' unit {$$ = 5;}
| unit ',' disk_id ',' disk ',' ucname {$$ = 8;}
| unit ',' disk_id ',' ucname ',' disk {$$ = 8;}
| ucname ',' unit ',' disk_id ',' disk {$$ = 9;}
| ucname ',' disk ',' disk_id ',' unit {$$ = 7;}
| disk ',' unit ',' disk_id ',' ucname {$$ = 8;}
| disk ',' ucname ',' disk_id ',' unit {$$ = 7;}
| unit ',' disk ',' disk_id ',' ucname {$$ = 8;}
| unit ',' ucname ',' disk_id ',' disk {$$ = 10;}
| ucname ',' unit ',' disk ',' disk_id {$$ = 9;}
| ucname ',' disk ',' unit ',' disk_id {$$ = 9;}
| disk ',' unit ',' ucname ',' disk_id {$$ = 10;}
| disk ',' ucname ',' unit ',' disk_id {$$ = 9;}
| unit ',' disk ',' ucname ',' disk_id {$$ = 10;}
| unit ',' ucname ',' disk ',' disk_id {$$ = 10;}
;
disc_command3: ucname {$$ = 0;}
| ucname ',' unit ',' disk {$$ = 1;}
| ucname ',' disk ',' unit {$$ = 1;}
| disk ',' unit ',' ucname {$$ = 2;}
| disk ',' ucname ',' unit {$$ = 1;}
| unit ',' disk ',' ucname {$$ = 2;}
| unit ',' ucname ',' disk {$$ = 2;}
| disk ',' ucname {$$ = 0;}
| unit ',' ucname {$$ = 2;}
| ucname ',' disk {$$ = 0;}
| ucname ',' unit {$$ = 1;}
;
disc_command3d: ucname {$$ = 0;}
| ucname ',' unit ',' disk {$$ = 1;}
| ucname ',' disk ',' unit {$$ = 1;}
| disk ',' unit ',' ucname {$$ = 2;}
| disk ',' ucname ',' unit {$$ = 1;}
| unit ',' disk ',' ucname {$$ = 2;}
| unit ',' ucname ',' disk {$$ = 2;}
| disk ',' ucname {$$ = 0;}
| unit ',' ucname {$$ = 2;}
| ucname ',' disk {$$ = 0;}
| ucname ',' unit {$$ = 1;}
| {$$ = 3;}
| unit ',' disk {$$ = 4;}
| disk ',' unit {$$ = 4;}
| disk {$$ = 3;}
| unit {$$ = 4;}
;
unit: Unum {code[progp++] = "PHA\nLDA #<0" + tostry($1) + "PHA\n";}
| U '(' e1iexpr ')'
| ON Unum {code[progp++] = "PHA\nLDA #<0" + tostry($2) + "PHA\n";}
| ON U '(' e1iexpr ')' 
;
ucname: '(' sexpr ')'
| STRINGTYPE {syntax4($1);}
;
disk: Dnum
| D '(' e1iexpr ')' {code[progp++] = "PLA\nPLA\n";}
;
disk_id: Iid {code[progp++] = "LDA #>0" + tostry($1) + "PHA\nLDA #<0" + tostry($1) + "PHA\n";}
;
ifexpr: iexpr {
     used_code["chkin"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nJSR xCHKIN\n";
}
| rexpr {
     used_code["chkin"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nJSR xCHKIN\n";
}
;
getvar: ivar {
     used_code["getkey_I0"] = 1;
     code[progp++] = "PLA\nSTA r0l\nPLA\nSTA r0h\nLDA #<GETIN\nSTA r5l\nLDA #>GETIN\nSTA r5h\nJSR ROMcall\n";
     code[progp++] = "JSR getkeyint0\n";
}
| rvar {
     used_code["getkey_I0"] = 1;
     code[progp++] = "PLA\nSTA r0l\nPLA\nSTA r0h\nLDA #<GETIN\nSTA r5l\nLDA #>GETIN\nSTA r5h\nJSR ROMcall\n";
     code[progp++] = "JSR getkeyint0\nINY\nSTA (r0l),Y\n";
}
| svar {
     used_code["getkey_S"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r4l\nPLA\nSTA r4h\nJSR getkey2\n";
}
;
getfvar: ivar {
     used_code["getkey_I"] = 1;
     code[progp++] = "PLA\nSTA r0l\nPLA\nJSR getkeyint\n";
}
| rvar {
     used_code["getkey_I"] = 1;
     code[progp++] = "PLA\nSTA r0l\nPLA\nJSR getkeyint\nINY\nSTA (r0l),Y\n";
}
| svar {
     used_code["getkey_S"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r4l\nPLA\nJSR getkey3\n";
}
;
labellist: lablistel
| lablistel ',' labellist
;
lablistel: NUMBER {code[progp++] = ".WORD "; reallocl[progp++] = $1;}
;
arraylist: array
| array ',' arraylist
;
array: IVAR '(' dimenlist ')' {
   if ($1->addr + 2 != ivarp) {
      for (map<string, Symbol>::iterator p = names.begin(); p != names.end(); p++) 
         if (p->second.type == IVAR && $1->addr < p->second.addr) p->second.addr -= 2;
      $1->addr = ivarp - 2;
   }
   $1->len += 2*$3;
   ivarp += 2*$3;
   syntax2($1);
}
| SVAR '(' dimenlist ')' {
   if ($1->addr + 2 != svarp) {
      for (map<string, Symbol>::iterator p = names.begin(); p != names.end(); p++) 
         if (p->second.type == SVAR && $1->addr < p->second.addr) p->second.addr -= 2;
      $1->addr = svarp - 2;
   }
   $1->len += 2*$3;
   svarp += 2*$3;
   syntax2($1);
}
| RVAR '(' dimenlist ')' {
   if ($1->addr + 3 != rvarp) {
      for (map<string, Symbol>::iterator p = names.begin(); p != names.end(); p++) 
         if (p->second.type == RVAR && $1->addr < p->second.addr) p->second.addr -= 3;
      $1->addr = rvarp - 3;
   }
   $1->len += 3*$3;
   rvarp += 3*$3;
   syntax2($1);
}
;
dimenlist: NUMBER {$$ = $1 + 1; v.push_back($1 + 1);}
| NUMBER ',' dimenlist {$$ = ($1 + 1)*$3; v.push_back($1 + 1);}
;
assign: ivar '=' iexpr {
     code[progp++] = "PLA\nTAX\nPLA\nSTA r3l\nPLA\nSTA r2l\nPLA\nJSR i_assign_i\n";
}
| ivar '=' rexpr {
     code[progp++] = "PLA\nTAX\nPLA\nSTA r3l\nPLA\nPLA\nSTA r2l\nPLA\nJSR i_assign_i\n";
}
| rvar '=' rexpr {
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nTAX\nPLA\nSTA r2l\nPLA\nJSR r_assign_r\n";
}
| rvar '=' iexpr {
     code[progp++] = "PLA\nSTA r3l\nLDX #0\nPLA\nSTA r3h\nBPL *+3\nDEX\nPLA\nSTA r2l\nPLA\nJSR r_assign_r\n";
}
| svar '=' svar {
     used_code["string"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nSTA r4h\nJSR s_ASSIGN_s0\n";
}
| svar '=' sexpr {
     used_code["s_assign_se"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nSTA $3F\nPLA\nSTA r2l\nPLA\nJSR s_ASSIGN_se\n";
}
| TIs '=' sexpr {
     used_code["mul16"] = 1;
     used_code["mul24"] = 1;
     used_code["s_assign_ti"] = 1;
     code[progp++] = "PLA\nSTA r5l\nPLA\nJSR s_ASSIGN_ti\n";
}
| MID '(' svar ',' iexpr ',' iexpr ')' '=' sexpr {
     used_code["midS_s_i_s"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nPLA\nPLA\n";
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nSTA r4l\nPLA\nJSR midS_s_i_s\n";
}
| MID '(' svar ',' iexpr ',' rexpr ')' '=' sexpr {
     used_code["midS_s_i_s"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nPLA\nPLA\nPLA\n";
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nSTA r4l\nPLA\nJSR midS_s_i_s\n";
}
| MID '(' svar ',' rexpr ',' iexpr ')' '=' sexpr {
     used_code["midS_s_i_s"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nPLA\nPLA\n";
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nPLA\nSTA r4l\nPLA\nJSR midS_s_i_s\n";
}
| MID '(' svar ',' rexpr ',' rexpr ')' '=' sexpr {
     used_code["midS_s_i_s"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nPLA\nPLA\nPLA\n";
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nPLA\nSTA r4l\nPLA\nJSR midS_s_i_s\n";
}
| MID '(' svar ',' iexpr ')' '=' sexpr {
     used_code["midS_s_i_s"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nPLA\nSTA r3l\nPLA\nPLA\nSTA r4l\nPLA\nJSR midS_s_i_s\n";
}
| MID '(' svar ',' rexpr ')' '=' sexpr {
     used_code["midS_s_i_s"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nPLA\nSTA r3l\nPLA\nPLA\nPLA\nSTA r4l\nPLA\nJSR midS_s_i_s\n";
}
;
def: DEF FN {deffn = 0;}
;
fnihead: RFN fnparams '=' {
    deffn = -2;
    code[progp++] = "JMP __" + tostry(fnep = locals++);
    code[progp++] = "__" + tostry(locals);
    $1->addr = locals++;
}
;
fnibody: e1rexpr {
    code[progp++] = "PLA\nSTA r5l\nPLA\nSTA r5h\nPLA\nSTA r2l\nRTS\n";
    deffn = -1;
    code[progp++] = "__" + tostry(fnep);
}
;
fnparams: '(' FVAR ')'
;
print: PRINT printnl
| PRINT prempty prlist
| PRINT ',' print2tab prlist
| PRINT '#' ofexpr  printnl endio
| PRINT '#' ofexpr ',' prlist endio
| PRINT USING puformat pulist
| PRINT '#' ofexpr ',' USING puformat pulist endio
;
endio: {
    used_code["clrch"] = 1;
    code[progp++] = "JSR xCLRCH\n";
}
;
ofexpr: iexpr {
    used_code["chout"] = 1;
    code[progp++] = "PLA\nTAX\nPLA\nJSR xCHOUT\n";
}
| rexpr {
    used_code["chout"] = 1;
    code[progp++] = "PLA\nTAX\nPLA\nPLA\nJSR xCHOUT\n";
}
;
prlist: sexpr ',' printstring print2tab prlist
| sexpr prempty printstring prlist
| sexpr printstring printnl
| sexpr ',' printstring print2tab
| sexpr ';' printstring
| iexpr ',' printint print2tab prlist
| iexpr prempty printint printspc prlist
| iexpr printint printnl
| iexpr ',' printint print2tab
| iexpr ';' printint printspc
| rexpr ',' printreal print2tab prlist
| rexpr prempty printreal printspc prlist
| rexpr printreal printnl
| rexpr ',' printreal print2tab
| rexpr ';' printreal printspc
| pexpr ',' print2tab prlist
| pexpr prempty prlist
| pexpr printnl
| pexpr ',' print2tab
| pexpr ';'
;
pexpr: SPC '(' iexpr ')' {
     used_code["pexpr"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nJSR spc\n";
}
| SPC '(' rexpr ')' {
     used_code["pexpr"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nJSR spc\n";
}
| TAB '(' iexpr ')' {
     used_code["pexpr"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nJSR tab\n";
}
| TAB '(' rexpr ')' {
     used_code["pexpr"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nJSR tab\n";
}
;
prempty:
| ';'
;
printnl: {code[progp++] = "LDA #$D\nJSR coutROM\n";}
;
printspc: {
     used_code["pexpr"] = 1;
     code[progp++] = "LDX #1\nJSR spc\n";
}
;
printint: {code[progp++] = "PLA\nTAX\nPLA\nJSR pr_int1\n";}
;
printreal: {
     used_code["pr_real"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nSTA r0l\nPLA\nJSR pr_real1\n";
}
;
print2tab: {
     used_code["print2tab"] = 1;
     code[progp++] = "JSR print2tab\n";
}
;
printstring: {code[progp++] = "PLA\nSTA r2l\nPLA\nJSR xstringout0\n";}
;
puformat: sexpr ';' {
     used_code["pu"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nJSR pu1\n";
}
;
pulist: sexpr pustr puall
| iexpr puint puall
| rexpr pureal puall
| sexpr ';' pustr pusc puall
| iexpr ';' puint pusc puall
| rexpr ';' pureal pusc puall
| sexpr ',' pustr pucomma pulist
| iexpr ',' puint pucomma pulist
| rexpr ',' pureal pucomma pulist
;
puint: {code[progp++] = "PLA\nTAX\nPLA\nJSR strS_i0\nJSR puint\n";}
;
pureal: {
    used_code["pr_real"] = 1;
    code[progp++] = "PLA\nTAX\nPLA\nSTA r0l\nPLA\nSTA r0h\nJSR redir\nJSR pr_real\nJSR puint\n";
}
;
pucomma: {code[progp++] = "JSR pucomma\n";}
;
pusc: {code[progp++] = "JSR pusc\n";}
;
pustr: {code[progp++] = "PLA\nSTA r5l\nPLA\nJSR pustr\n";}
;
puall: {code[progp++] = "JSR puall\n";}
;
input: INPUT '#' ifexpr ',' varlistf  {
     code[progp++] = "JSR strfromfile_extra\n";
} endio
| input stringtype varlist {
     code[progp++] = "JSR strfromkbd_extra\n";
}
;
stringtype: {code[progp++] = "JSR input1\n";}
| STRINGTYPE ';' {
     if ($1->len > 0) {
        if ($1->used == 0) {
           $1->used++;
           data1[stringp++] = ".byte " + tostr($1->len);
           data1[stringp++] = "\n.text \"" + *$1->name + "\"\n";
        }
        code[progp++] = "LDA #<";
        reallocs[progp] = $1;
        code[progp++] = tostr($1->addr);
        code[progp++] = "\nSTA r2l\n";
        code[progp++] = "LDA #>";
        reallocs[progp] = $1;
        code[progp++] = tostr($1->addr);
        code[progp++] = "\nJSR xstringout0\nJSR input1\n";
     }
}
;
input: INPUT {
     used_code["input"] = 1;
     code[progp++] = "JSR input0\n";
}
;
varlistf: svarf
| svarf ',' varlistf
| ivarf
| ivarf ',' varlistf
| rvarf
| rvarf ',' varlistf
;
svarf: svar {
     used_code["strfromfile"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r4l\nPLA\nJSR strfromfile\n";}
;
ivarf: ivar {
     used_code["intfromfile"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nJSR intfromfile\n";
}
;
rvarf: rvar {
     used_code["intfromfile"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nJSR intfromfile\nLDA r0h\nINY\nSTA (r1l),Y\n";
}
;
varlist: svark
| svark ',' varlist
| ivark
| ivark ',' varlist
| rvark
| rvark ',' varlist
;
svark: svar {
     used_code["strfromkbd"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r4l\nPLA\nJSR strfromkbd\n";
}
;
ivark: ivar {
     used_code["intfromkbd"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nJSR intfromkbd\n";
}
;
rvark: rvar {
     used_code["intfromkbd"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nJSR intfromkbd\nLDA r0h\nINY\nSTA (r1l),Y\n";
}
;
varlistd: svard
| svard ',' varlistd
| ivard
| ivard ',' varlistd
| rvard
| rvard ',' varlistd
;
svard: svar {
     used_code["strfromdata"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r4l\nPLA\nJSR strfromdata\n";
}
;
ivard: ivar {
     used_code["intfromdata"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nJSR intfromdata\n";
}
;
rvard: rvar {
     used_code["intfromdata"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nJSR intfromdata\nLDA r0h\nINY\nSTA (r1l),Y\n";
}
;
load: LOAD sexpr ',' e1iexpr ',' e1iexpr {
     used_code["load"] = 1;
     code[progp++] = "PLA\nSTA $AD\nPLA\nPLA\nSTA $AE\nPLA\nPLA\nSTA $AF\nPLA\nJMP load\n";
}
| LOAD sexpr ',' e1iexpr {
     used_code["load"] = 1;
     code[progp++] = "PLA\nSTA $AE\nPLA\nPLA\nSTA $AF\nLDA #0\nSTA $AD\nPLA\nJMP load\n";
}
| LOAD sexpr {
     used_code["load"] = 1;
     code[progp++] = "PLA\nSTA $AF\nPLA\nLDX #0\nSTX $AD\nINX\nSTX $AE\nJMP load\n";
}
;
verify: VERIFY sexpr ',' e1iexpr ',' e1iexpr {
     used_code["verify"] = 1;
     code[progp++] = "PLA\nSTA $AD\nPLA\nPLA\nSTA $AE\nPLA\nPLA\nSTA $AF\nPLA\nJSR verify\n";
}
| VERIFY sexpr ',' e1iexpr {
     used_code["verify"] = 1;
     code[progp++] = "PLA\nSTA $AE\nPLA\nPLA\nSTA $AF\nLDA #0\nSTA $AD\nPLA\nJSR verify\n";
}
| VERIFY sexpr {
     used_code["verify"] = 1;
     code[progp++] = "PLA\nSTA $AF\nPLA\nLDX #0\nSTX $AD\nINX\nSTX $AE\nJSR verify\n";
}
;
save: SAVE sexpr ',' e1iexpr ',' e1iexpr {
     used_code["save"] = 1;
}
| SAVE sexpr ',' e1iexpr {
     used_code["save"] = 1;
}
| SAVE sexpr {
     used_code["save"] = 1;
}
;
for: FOR IVAR '=' e1iexpr {
     code[progp++] = "PLA\nSTA ";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = "PLA\nSTA 1+";
     realloca[progp++] = $2;
     code[progp++] = "\n";
} TO e1iexpr step {
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 1;
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 3;
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 2;
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 4;
     code[progp++] = "__" + tostry(locals);
     labels[-$1] = locals++;
} operend operlist NEXT {
     code[progp++] = "CLC\nLDA ";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = ".BYTE $69\n"; //adc #step_lo
     code[progp++] = "__" + tostry(locals) + ".BYTE 0\n";
     labels[-$1 - 1] = locals;
     code[progp++] = "STA r2l\nSTA ";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = "\nLDA 1+";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = ".BYTE $69\n"; //adc #step_hi
     code[progp++] = "__" + tostry(locals + 4) + ".BYTE 0\n";
     labels[-$1 - 3] = locals + 4;
     code[progp++] = "STA r2h\nSTA 1+";
     realloca[progp++] = $2;
     code[progp++] = "\n";

     code[progp++] = "SEC\nLDA r2l\n";
     code[progp++] = ".BYTE $E9\n"; //SBC #limit_lo
     code[progp++] = "__" + tostry(locals + 1) + ".BYTE 0\n";
     labels[-$1 - 2] = locals + 1;
     code[progp++] = "STA r2l\n";
     code[progp++] = "LDA r2h\n";
     code[progp++] = ".BYTE $E9\n"; //SBC #limit_hi
     code[progp++] = "__" + tostry(locals + 5) + ".BYTE 0\n";
     labels[-$1 - 4] = locals + 5;
     code[progp++] = "STA r2h\nORA r2l\n";
     code[progp++] = "BEQ __" + tostry(locals + 2);

     code[progp++] = "LDA __" + tostry(locals + 4);
     code[progp++] = "EOR r2h\n";
     code[progp++] = "BPL __" + tostry(locals + 3);
     code[progp++] = "__" + tostry(locals + 2);
     code[progp++] = "JMP __" + tostry(labels[-$1]);
     code[progp++] = "__" + tostry(locals + 3);
     locals += 6;
}
;
step: {code[progp++] = "LDA #0\nPHA\nLDA #1\nPHA\n";}
| STEP e1iexpr
;
for: FOR RVAR '=' e1rexpr {
     code[progp++] = "PLA\nSTA ";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = "PLA\nSTA 1+";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = "PLA\nSTA 2+";
     realloca[progp++] = $2;
     code[progp++] = "\n";
} TO e1rexpr rstep {
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 1;
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 3;
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 5;
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 2;
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 4;
     code[progp++] = "PLA\nSTA ";
     reallocl[progp++] = -$1 - 6;
     code[progp++] = "__" + tostry(locals);
     labels[-$1] = locals++;
} operend operlist NEXT {
     code[progp++] = "CLC\nLDA ";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = ".BYTE $69\n"; //adc #step_lo
     code[progp++] = "__" + tostry(locals) + ".BYTE 0\n";
     labels[-$1 - 1] = locals;
     code[progp++] = "STA r2l\nSTA ";
     realloca[progp++] = $2;
     code[progp++] = "\nLDA 1+";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = ".BYTE $69\n"; //adc #step_mid
     code[progp++] = "__" + tostry(locals + 4) + ".BYTE 0\n";
     labels[-$1 - 3] = locals + 4;
     code[progp++] = "STA r2h\nSTA 1+";
     realloca[progp++] = $2;
     code[progp++] = "\nLDA 2+";
     realloca[progp++] = $2;
     code[progp++] = "\n";
     code[progp++] = ".BYTE $69\n"; //adc #step_hi
     code[progp++] = "__" + tostry(locals + 6) + ".BYTE 0\n";
     labels[-$1 - 5] = locals + 6;
     code[progp++] = "STA r3l\nSTA 2+";
     realloca[progp++] = $2;
     code[progp++] = "\n";

     code[progp++] = "SEC\nLDA r2l\n";
     code[progp++] = ".BYTE $E9\n"; //SBC #limit_lo
     code[progp++] = "__" + tostry(locals + 1) + ".BYTE 0\n";
     labels[-$1 - 2] = locals + 1;
     code[progp++] = "STA r2l\n";
     code[progp++] = "LDA r2h\n";
     code[progp++] = ".BYTE $E9\n"; //SBC #limit_mid
     code[progp++] = "__" + tostry(locals + 5) + ".BYTE 0\n";
     labels[-$1 - 4] = locals + 5;
     code[progp++] = "STA r2h\n";
     code[progp++] = "LDA r3l\n";
     code[progp++] = ".BYTE $E9\n"; //SBC #limit_mid
     code[progp++] = "__" + tostry(locals + 7) + ".BYTE 0\n";
     labels[-$1 - 6] = locals + 7;
     code[progp++] = "STA r3l\nORA r2l\nORA r2h\n";
     code[progp++] = "BEQ __" + tostry(locals + 2);

     code[progp++] = "LDA __" + tostry(locals + 6);
     code[progp++] = "EOR r3l\n";
     code[progp++] = "BPL __" + tostry(locals + 3);
     code[progp++] = "__" + tostry(locals + 2);
     code[progp++] = "JMP __" + tostry(labels[-$1]);
     code[progp++] = "__" + tostry(locals + 3);
     locals += 8;
}
;
rstep: {code[progp++] = "LDA #0\nPHA\nPHA\nLDA #1\nPHA\n";}
| STEP e1rexpr
;
e1rexpr: rexpr
| iexpr {code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nBPL *+3\nDEX\nTAY\nTXA\nPHA\nTYA\nPHA\nLDA r2l\nPHA\n";}
;
if: IF iexpr THEN {
     code[progp++] = "PLA\nSTA r2l\nPLA\nORA r2l\n";
     code[progp++] = "BNE *+5\nJMP ";  //if possible then optimize to BEQ?
     ifa[ifc++] = reallocl[progp++] = -$1;
} ioperlist {
     code[progp++] = "__" + tostry(locals);
     for (int i = 0; i < ifc; i++)
        labels[ifa[i]] = locals;
     for (int i = 0; i < elset; i++)
        labels[elsea[i]] = locals;
     locals++;
}
| IF rexpr THEN {
     code[progp++] = "PLA\nSTA r2l\nPLA\nORA r2l\nSTA r2l\nPLA\nORA r2l\n";
     code[progp++] = "BNE *+5\nJMP ";  //if possible then optimize to BEQ?
     ifa[ifc++] = reallocl[progp++] = -$1;
} ioperlist {
     code[progp++] = "__" + tostry(locals);
     for (int i = 0; i < ifc; i++)
        labels[ifa[i]] = locals;
     for (int i = 0; i < elset; i++)
        labels[elsea[i]] = locals;
     locals++;
}
;
ioperlist: oper operelse
;
operelse:
| ':' else ioperlist
| ':' oper operelse
;
else: ELSE {
     if (elsec == 1)  {
        code[progp++] = "JMP ";
        reallocl[progp++] = -$1;
        code[progp++] = "__" + tostry(locals);
        for (int i = 0; i < ifc; i++)
           labels[ifa[i]] = locals;
        locals++;
        ifc = 0;
        elsea[elset++] = -$1;
     }
     if (elsec == 2)  {
        code[progp++] = "JMP ";
        elsea[elset++] = reallocl[progp++] = -$1;
     }
}
;
do: DO {
     code[progp++] = "__" + tostry(locals);
     labels[-$1] = locals++;
     dostore[++dolevel] = -$1;
} pre_while_until operend operlist LOOP post_while_until {
     code[progp++] = "__" + tostry(locals);
     labels[-$1 - 1] = locals++;
     dolevel--;
}
;
pre_while_until: 
| WHILE_UNTIL iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nORA r2l\n";
     if ($1)
        code[progp++] = "BNE *+5\n";
     else
        code[progp++] = "BEQ *+5\n";
     code[progp++] = "JMP ";
     reallocl[progp++] = dostore[dolevel] - 1;
     code[progp++] = "\n";
}
| WHILE_UNTIL rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nORA r2l\nSTA r2l\nPLA\nORA r2l\n";
     if ($1)
        code[progp++] = "BNE *+5\n";
     else
        code[progp++] = "BEQ *+5\n";
     code[progp++] = "JMP ";
     reallocl[progp++] = dostore[dolevel] - 1;
     code[progp++] = "\n";
}
;
post_while_until: {
     code[progp++] = "JMP  ";
     reallocl[progp++] = dostore[dolevel];
     code[progp++] = "\n";
}
| WHILE_UNTIL iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nORA r2l\n";
     if ($1)
        code[progp++] = "BEQ *+5\n";
     else
        code[progp++] = "BNE *+5\n";
     code[progp++] = "JMP ";
     reallocl[progp++] = dostore[dolevel];
     code[progp++] = "\n";
}
| WHILE_UNTIL rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nORA r2l\nSTA r2l\nPLA\nORA r2l\n";
     if ($1)
        code[progp++] = "BEQ *+5\n";
     else
        code[progp++] = "BNE *+5\n";
     code[progp++] = "JMP ";
     reallocl[progp++] = dostore[dolevel];
     code[progp++] = "\n";
}
;
exit: EXIT {
   if (dolevel == 0) throw (string) "EXIT without DO";
   code[progp++] = "JMP ";
   reallocl[progp++] = dostore[dolevel] - 1;
   code[progp++] = "\n";
}
;
sys: SYS iexpr {
   used_code["sys"] = 1;
   code[progp++] = "PLA\nSTA $14\nPLA\nJSR sys0\n";
}
| SYS rexpr {
   used_code["sys"] = 1;
   code[progp++] = "PLA\nSTA $14\nPLA\nSTA $15\nPLA\nJSR sys\n";
}
;
char: CHAR e0iexpr ',' e1iexpr ',' e1iexpr ',' sexpr ',' e1iexpr {
     used_code["char"] = 1;
     code[progp++] = "PLA\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\nPLA\nTAY\nPLA\nPLA\n";
     code[progp++] = "JSR char\nPLA\n";
}
| CHAR e0iexpr ',' e1iexpr ',' e1iexpr ',' sexpr {
     used_code["char"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nTAX\nPLA\nPLA\nTAY\nPLA\nPLA\n";
     code[progp++] = "JSR char\nPLA\n";
}
;
e0iexpr: iexpr
| {code[progp++] = "LDA #0\nPHA\nLDA #1\nPHA\n";}
| rexpr {code[progp++] = "PLA\nTAX\nPLA\nTAY\nPLA\nTYA\nPHA\nTXA\nPHA\n";}
;
e1iexpr: iexpr
| rexpr {code[progp++] = "PLA\nTAX\nPLA\nTAY\nPLA\nTYA\nPHA\nTXA\nPHA\n";}
;
open: OPEN e1iexpr ',' e1iexpr ',' e1iexpr ',' sexpr {
     used_code["open"] = 1;
     code[progp++] = "PLA\nSTA $af\nPLA\nSTA $b0\nPLA\nSTA $ad\nPLA\nPLA\nSTA $ae\nPLA\nPLA\nSTA $ac\nPLA\nJSR openfile\n";
}
| OPEN e1iexpr ',' e1iexpr ',' e1iexpr {
     used_code["open"] = 1;
     code[progp++] = "PLA\nSTA $ad\nPLA\nPLA\nSTA $ae\nPLA\nPLA\nSTA $ac\nPLA\nLDA #0\nSTA $ab\nJSR openfile0\n";
}
| OPEN e1iexpr ',' e1iexpr {
     used_code["open"] = 1;
     code[progp++] = "PLA\nSTA $ae\nPLA\nPLA\nSTA $ac\nPLA\nLDY #0\nSTY $ab\nSTY $ad\nJSR openfile0\n";
}
;
sound: SOUND e1iexpr ',' e1iexpr ',' e1iexpr {
     used_code["sound"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nTAX\nPLA\nJSR sound\n";
}
;
ivar: IVAR {syntax3($1);}
| IVAR '(' iexprlist ')' {syntax1($1);}
;
rvar: RVAR {syntax3($1);}
| FVAR {code[progp++] = "LDA #1\nPHA\nLDA baseptr\nPHA\n";}
| RVAR '(' iexprlist ')' {syntax1($1);}
;
iexprlist: e1iexpr {dimcount = 1;}
| e1iexpr ',' iexprlist {dimcount++;}
;
svar: SVAR {syntax3($1);}
| SVAR '(' iexprlist ')' {syntax1($1);}
;
rexpr: REAL {
    code[progp++] = "LDA #" + tostr($1/(1<<16)) + "\nPHA\nLDA #" + tostr(($1&65535)/256) + "\nPHA\n";
    code[progp++] = "LDA #" + tostry($1&255) + "PHA\n";
}
| rvar {
    code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDY #2\n";
    code[progp++] = "LDA (r2l),Y\nPHA\nDEY\nLDA (r2l),Y\nPHA\nDEY\nLDA (r2l),Y\nPHA\n";
}
| FRE {
     used_code["gc"] = 1;
     code[progp++] = "LDA #0\nPHA\nSTA r5h\nJSR gc0\nSEC\nLDA #<strdmax\nSBC strdcurre\nTAX\n";
     code[progp++] = "LDA #>strdmax\nSBC strdcurre+1\nPHA\nTXA\nPHA\n";
}
| TI {
     code[progp++] = "LDA $a3\nPHA\nLDA $a4\nPHA\n";
     code[progp++] = "LDA $a5\nPHA\n";
}
| DEC '(' sexpr ')' {
     used_code["hex2dec"] = 1;
     code[progp++] = "PLA\nSTA r4l\nPLA\nJSR hex2dec\nLDA #0\nPHA\nLDA r3h\nPHA\nLDA r3l\nPHA\n";
}
| VAL '(' sexpr ')' {
     used_code["str2dec"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nJSR str2dec\nLDA r0h\nPHA\nLDA r4h\nPHA\nLDA r4l\nPHA\n";
}
| ABS '(' rexpr ')' {
     code[progp++] = "PLA\nTAX\nPLA\nSTA r2l\nPLA\nBPL __" + tostr(locals)
       + "\nEOR #$FF\nTAY\nTXA\nEOR #$FF\nCLC\nADC #1\nTAX\nLDA r2l\nEOR #$FF\nADC #0\nSTA r2l\nTYA\nADC #0\n__" 
       + tostry(locals) + "PHA\nLDA r2l\nPHA\nTXA\nPHA\n";
     locals++;
}
| iexpr '+' iexpr {
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nBPL *+3\nDEX\nSTX r3l\nSTA r2h\nPLA\nCLC\nADC r2l\nSTA r2l\n";
     code[progp++] = "LDX #0\nPLA\nBPL *+3\nDEX\nADC r2h\nTAY\nTXA\nADC r3l\nPHA\nTYA\nPHA\nLDA r2l\nPHA\n";
}
| rexpr '+' iexpr {
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nBPL *+3\nDEX\nSTX r3l\nSTA r2h\nPLA\nCLC\nADC r2l\nTAX\n";
     code[progp++] = "PLA\nADC r2h\nTAY\nPLA\nADC r3l\nPHA\nTYA\nPHA\nTXA\nPHA\n";
}
| iexpr '+' rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nCLC\nADC r2l\nSTA r2l\nLDX #0\nPLA\n";
     code[progp++] = "BPL *+3\nDEX\nADC r2h\nTAY\nTXA\nADC r3l\nPHA\nTYA\nPHA\nLDA r2l\nPHA\n";
}
| rexpr '+' rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r0l\nPLA\nCLC\nADC r2l\nTAX\nPLA\nADC r2h\n";
     code[progp++] = "TAY\nPLA\nADC r0l\nPHA\nTYA\nPHA\nTXA\nPHA\n";
}
| iexpr '-' iexpr {
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nBPL *+3\nDEX\nSTX r3l\nSTA r2h\nPLA\nSEC\nSBC r2l\nSTA r2l\n";
     code[progp++] = "LDX #0\nPLA\nBPL *+3\nDEX\nSBC r2h\nTAY\nTXA\nSBC r3l\nPHA\nTYA\nPHA\nLDA r2l\nPHA\n";
}
| rexpr '-' iexpr {
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nBPL *+3\nDEX\nSTX r3l\nSTA r2h\nPLA\nSEC\nSBC r2l\nTAX\n";
     code[progp++] = "PLA\nSBC r2h\nTAY\nPLA\nSBC r3l\nPHA\nTYA\nPHA\nTXA\nPHA\n";
}
| iexpr '-' rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSEC\nSBC r2l\nSTA r2l\nLDX #0\nPLA\n";
     code[progp++] = "BPL *+3\nDEX\nSBC r2h\nTAY\nTXA\nSBC r3l\nPHA\nTYA\nPHA\nLDA r2l\nPHA\n";
}
| rexpr '-' rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r0l\nPLA\nSEC\nSBC r2l\nTAX\nPLA\nSBC r2h\n";
     code[progp++] = "TAY\nPLA\nSBC r0l\nPHA\nTYA\nPHA\nTXA\nPHA\n";
}
| iexpr '*' iexpr {
     used_code["mul24"] = 1;
     code[progp++] = "PLA\nSTA r1l\nLDX #0\nPLA\nSTA r1h\nBPL *+3\nDEX\nSTX r4l\nPLA\nSTA r2l\nLDX #0\n";
     code[progp++] = "PLA\nSTA r2h\nBPL *+3\nDEX\nSTX r4h\nJSR mul24\nPHA\nLDA r0l\nPHA\nTXA\nPHA\n";
}
| iexpr '*' rexpr {
     used_code["mul24"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nPLA\nSTA r4l\nPLA\nSTA r2l\nLDX #0\nPLA\nSTA r2h\n";
     code[progp++] = "BPL *+3\nDEX\nSTX r4h\nJSR mul24\nPHA\nLDA r0l\nPHA\nTXA\nPHA\n";
}
| rexpr '*' iexpr {
     used_code["mul24"] = 1;
     code[progp++] = "PLA\nSTA r1l\nLDX #0\nPLA\nSTA r1h\nBPL *+3\nDEX\nSTX r4l\nPLA\nSTA r2l\nPLA\nSTA r2h\n";
     code[progp++] = "PLA\nSTA r4h\nJSR mul24\nPHA\nLDA r0l\nPHA\nTXA\nPHA\n";
}
| rexpr '*' rexpr {
     used_code["mul24"] = 1;
     code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nPLA\nSTA r4l\nPLA\nSTA r2l\nPLA\nSTA r2h\n";
     code[progp++] = "PLA\nSTA r4h\nJSR mul24\nPHA\nLDA r0l\nPHA\nTXA\nPHA\n";
}
| rexpr '/' iexpr {
     used_code["div24_16"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r1l\nJSR div24_16\n";
     code[progp++] = "LDA r1l\nPHA\nLDA r3h\nPHA\nLDA r3l\nPHA\n";
}
| rexpr '/' rexpr {
     used_code["div24"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r5l\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r1l\n";
     code[progp++] = "JSR div24\nLDA r1l\nPHA\nLDA r3h\nPHA\nLDA r3l\nPHA\n";
}
| iexpr '^' iexpr {
     used_code["power24"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nSTA $14\nLDX #0\nPLA\nSTA $15\nBPL *+3\nDEX\nSTX r3h\n";
     code[progp++] = "JSR power24\nLDA r1l\nPHA\nLDA r5h\nPHA\nLDA r5l\nPHA\nTXA\nPHA\n";
}
| rexpr '^' iexpr {
     used_code["power24"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nSTA $14\nPLA\nSTA $15\nPLA\nSTA r3h\n";
     code[progp++] = "JSR power24\nLDA r5h\nPHA\nLDA r5l\nPHA\nTXA\nPHA\n";
}
| iexpr '^' rexpr {
     used_code["power24"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nPLA\nSTA $14\nLDX #0\nPLA\nSTA $15\nBPL *+3\nDEX\nSTX r3h\n";
     code[progp++] = "JSR power24\nLDA r5h\nPHA\nLDA r5l\nPHA\nTXA\nPHA\n";
}
| rexpr '^' rexpr {
     used_code["power24"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nPLA\nSTA $14\nPLA\nSTA $15\nPLA\nSTA r3h\n";
     code[progp++] = "JSR power24\nLDA r5h\nPHA\nLDA r5l\nPHA\nTXA\nPHA\n";
}
| '-' rexpr %prec NOT {
     code[progp++] = "PLA\nEOR #$FF\nTAX\nPLA\nEOR #$FF\nTAY\nPLA\nEOR #$FF\nINX\nBNE __"
        + tostry(locals) + "INY\nBNE *+5\nCLC\nADC #1\n__" + tostry(locals) + "PHA\nTYA\nPHA\nTXA\nPHA\n";
     locals++;
}
| '(' rexpr ')'
| INT '(' rexpr ')'
| EXP '(' iexpr ')' {
     used_code["exp"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nTAY\nTYA\nPHP\nLDA #0\nPLP\nJSR exp\nPHA\nTYA\nPHA\nTXA\nPHA\n";
}
| EXP '(' rexpr ')' {
     used_code["exp"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nTAY\nPLA\nJSR exp\nPHA\nTYA\nPHA\nTXA\nPHA\n";
}
| FN {callfn = 0;} RFN fncmain
| USR '(' iexpr ')' {
     code[progp++] = "PLA\nSTA $61\nPLA\nSTA $62\nLDA #0\nSTA $63\n";
     code[progp++] = "JSR $500\n";
     code[progp++] = "LDA $63\nPHA\nLDA $62\nPHA\nLDA $61\nPHA\n";
}
| USR '(' rexpr ')' {
     code[progp++] = "PLA\nSTA $61\nPLA\nSTA $62\nPLA\nSTA $63\n";
     code[progp++] = "JSR $500\n";
     code[progp++] = "LDA $63\nPHA\nLDA $62\nPHA\nLDA $61\nPHA\n";
}
;
iexpr: NUMBER {code[progp++] = "LDA #>0" + tostry($1) + "PHA\nLDA #<0" + tostry($1) + "PHA\n";}
| ivar {
//     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDY #1\n";
//     code[progp++] = "LDA (r2l),Y\nPHA\nDEY\nLDA (r2l),Y\nPHA\n";
     code[progp++] = "JSR getvarval\n";
}
| PEEK '(' iexpr ')' {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDY #0\nTYA\nPHA\nLDA (r2l),Y\nPHA\n";
}
| PEEK '(' rexpr ')' {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nLDY #0\nTYA\nPHA\nLDA (r2l),Y\nPHA\n";
}
| ABS '(' iexpr ')' {
     code[progp++] = "PLA\nTAX\nPLA\nBPL __" + tostr(locals)
       + "\nEOR #$FF\nTAY\nTXA\nEOR #$FF\nTAX\nINX\nBNE *+3\nINY\nTYA\n__" + tostry(locals) + "PHA\nTXA\nPHA\n";
     locals++;
}
| SGN '(' iexpr ')' {
     code[progp++] = "PLA\nSTA r2l\nLDY #$FF\nPLA\nBMI __" + tostry(locals) + "INY\nORA r2l\nBEQ __"
        + tostry(locals) + "TYA\nPHA\nLDA #1\nBNE __" + tostry(locals + 1) + "__" + tostr(locals)
        + "\nTYA\nPHA\n__" + tostry(locals + 1) + "PHA\n";
     locals += 2;
}
| SGN '(' rexpr ')' {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDY #$FF\nPLA\nBMI __" 
        + tostry(locals) + "INY\nORA r2l\nORA r2h\nBEQ __"
        + tostry(locals) + "TYA\nPHA\nLDA #1\nBNE __" + tostry(locals + 1) + "__" + tostr(locals)
        + "\nTYA\nPHA\n__" + tostry(locals + 1) + "PHA\n";
     locals += 2;
}
| POS {code[progp++] = "LDA #0\nPHA\nLDA $CA\nPHA\n";}
| ASC '(' sexpr ')' {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDY #0\nTYA\nPHA\nLDA (r2l),Y\nBEQ __"
        + tostry(locals) + "INY\nLDA (r2l),Y\n__" + tostry(locals) + "PHA\n";
     locals++;
}
| JOY '(' iexpr ')' {
     used_code["joy"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nJSR joy\nPHA\nTXA\nPHA\n";
}
| JOY '(' rexpr ')' {
     used_code["joy"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nJSR joy\nPHA\nTXA\nPHA\n";
}
| PI {code[progp++] = "LDA #0\nPHA\nLDA #3\nPHA\n";}
| LOG '(' iexpr ')' {
     used_code["log"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nTAY\nTYA\nPHP\nLDA #0\nPLP\nJSR log\nPHA\nTYA\nPHA\n";
}
| LOG '(' rexpr ')' {
     used_code["log"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nTAY\nPLA\nJSR log\nPHA\nTYA\nPHA\n";
}
| SQR '(' iexpr ')' {
     used_code["sqr"] = 1;
     used_code["div24"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nTAY\nTYA\nPHP\nLDA #0\nPLP\nJSR sqr\nPHA\nTXA\nPHA\n";
}
| SQR '(' rexpr ')' {
     used_code["sqr"] = 1;
     used_code["div24"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nTAY\nPLA\nJSR sqr\nPHA\nTXA\nPHA\n";
}
| ATN '(' iexpr ')' {
     used_code["atn"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nTAY\nTYA\nPHP\nLDA #0\nPLP\nJSR atn\nPHA\nTXA\nPHA\n";
}
| ATN '(' rexpr ')' {
     used_code["atn"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nTAY\nPLA\nJSR atn\nPHA\nTXA\nPHA\n";
}
| DS {
     used_code["DSi"] = 1;
     used_code["DSs"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "JSR DSi\nPHA\nTXA\nPHA\n";
}
| INT '(' iexpr ')'
| LEN '(' sexpr ')' {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDY #0\nTYA\nPHA\nLDA (r2l),Y\nPHA\n";
}
| INSTR '(' sexpr ',' sexpr ')' {
     used_code["instr"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nSTA r4h\nLDY #0\nJSR instr\nPHA\nTYA\nPHA\n";
}
| INSTR '(' sexpr ',' sexpr ',' iexpr ')' {
     used_code["instr"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nSTA r4h\nDEY\nJSR instr\nPHA\nTYA\nPHA\n";
}
| INSTR '(' sexpr ',' sexpr ',' rexpr ')' {
     used_code["instr"] = 1;
     code[progp++] = "PLA\nTAY\nPLA\nPLA\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nSTA r4h\nDEY\nJSR instr\nPHA\nTYA\nPHA\n";
}
| ST {code[progp++] = "LDA #0\nPHA\nLDA $90\nPHA\n";}
| iexpr '/' iexpr {
     used_code["div16"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nJSR div16\nLDA r3h\nPHA\nLDA r3l\nPHA\n";
}
| iexpr '/' rexpr {
     used_code["div16"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nBEQ __" + tostry(locals) + "LDA #0\nPHA\nBEQ __"
         + tostry(locals + 1) + "__" + tostry(locals) + "PLA\nSTA r3l\n";
     code[progp++] = "PLA\nSTA r3h\nJSR div16\nLDA r3h\nPHA\nLDA r3l\n__" + tostry(locals + 1) + "PHA\n";
     locals += 2;
}
| '-' iexpr %prec NOT {
     code[progp++] = "PLA\nEOR #$FF\nTAX\nPLA\nEOR #$FF\nINX\nBNE __"
        + tostry(locals) + "CLC\nADC #1\n__" + tostry(locals) + "PHA\nTXA\nPHA\n";
     locals++;
}
| '(' iexpr ')'
| iexpr GE iexpr {
     used_code["i_GE_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r3l\nPLA\nSEC\nSBC r2l\nPLA\nJSR i_GE_i\n";
     code[progp++] = "PHA\nPHA\n";
}
| rexpr GE rexpr {
     used_code["i_GE_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nSEC\nPLA\nSBC r2l\nPLA\nSBC r2h\n";
     code[progp++] = "PLA\nJSR i_GE_i\nPHA\nPHA\n";
}
| rexpr GE iexpr {
     used_code["i_GE_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nSTA r2h\nBPL *+3\nDEX\nSTX r3l\nSEC\nPLA\nSBC r2l\nPLA\nSBC r2h\n";
     code[progp++] = "PLA\nJSR i_GE_i\nPHA\nPHA\n";
}
| iexpr GE rexpr {
     used_code["i_GE_i"] = 1;
     used_code["i_GE_r"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nSEC\nPLA\nSBC r2l\nLDX #0\nPLA\n";
     code[progp++] = "JSR i_GE_r\nPHA\nPHA\n";
}
| rexpr GT rexpr {
     used_code["i_GT_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSEC\nSBC r2l\nSTA r2l\nPLA\nSBC r2h\nSTA r2h\n";
     code[progp++] = "PLA\nJSR i_GT_i\nPHA\nPHA\n";
}
| iexpr GT iexpr {
     used_code["i_GT_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r3l\nPLA\nSEC\nSBC r2l\nSTA r2l\nPLA\n";
     code[progp++] = "LDY #0\nSTY r2h\nJSR i_GT_i\nPHA\nPHA\n";
}
| rexpr GT iexpr {
     used_code["i_GT_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nSTA r2h\nBPL *+3\nDEX\nSTX r3l\nSEC\nPLA\nSBC r2l\nSTA r2l\n";
     code[progp++] = "PLA\nSBC r2h\nSTA r2h\nPLA\nJSR i_GT_i\nPHA\nPHA\n";
}
| iexpr GT rexpr {
     used_code["i_GT_i"] = 1;
     used_code["i_GT_r"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSEC\nSBC r2l\nSTA r2l\nLDX #0\nPLA\n";
     code[progp++] = "JSR i_GT_r\nPHA\nPHA\n";
}
| rexpr LT rexpr {
     used_code["i_LT_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nSEC\nPLA\nSBC r2l\nPLA\nSBC r2h\n";
     code[progp++] = "PLA\nJSR i_LT_i\nPHA\nPHA\n";
}
| iexpr LT rexpr {
     used_code["i_LT_i"] = 1;
     used_code["i_LT_r"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nSEC\nPLA\nSBC r2l\nLDX #0\nPLA\n";
     code[progp++] = "JSR i_LT_r\nPHA\nPHA\n";
}
| rexpr LT iexpr {
     used_code["i_LT_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nBPL *+3\nDEX\nSTA r2h\nSTX r3l\nSEC\nPLA\nSBC r2l\nPLA\nSBC r2h\n";
     code[progp++] = "PLA\nJSR i_LT_i\nPHA\nPHA\n";
}
| iexpr LT iexpr {
     used_code["i_LT_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r3l\nSEC\nPLA\nSBC r2l\nPLA\nJSR i_LT_i\nPHA\nPHA\n";
}
| rexpr LE rexpr {
     used_code["i_LE_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nSEC\nPLA\nSBC r2l\nSTA r2l\nPLA\nSBC r2h\nSTA r2h\n";
     code[progp++] = "PLA\nJSR i_LE_i\nPHA\nPHA\n";
}
| iexpr LE rexpr {
     used_code["i_LE_i"] = 1;
     used_code["i_LE_r"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSEC\nSBC r2l\nSTA r2l\nLDX #0\nPLA\n";
     code[progp++] = "JSR i_LE_r\nPHA\nPHA\n";
}
| rexpr LE iexpr {
     used_code["i_LE_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nSTA r2h\nBPL *+3\nDEX\nSTX r3l\nSEC\nPLA\nSBC r2l\nSTA r2l\nPLA\n";
     code[progp++] = "SBC r2h\nSTA r2h\nPLA\nJSR i_LE_i\nPHA\nPHA\n";
}
| iexpr LE iexpr {
     used_code["i_LE_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r3l\nSEC\n PLA\nSBC r2l\nSTA r2l\nLDY #0\nSTY r2h\n";
     code[progp++] = "PLA\nJSR i_LE_i\nPHA\nPHA\n";
}
| rexpr '=' rexpr {
     used_code["i_EQ_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nTAY\nPLA\nJSR i_EQ_i\nPHA\nPHA\n";
}
| rexpr '=' iexpr {
     used_code["i_EQ_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nSTA r2h\nBPL *+3\nDEX\nSTX r3l\nPLA\nSTA r3h\nPLA\nTAY\n";
     code[progp++] = "PLA\nJSR i_EQ_i\nPHA\nPHA\n";
}
| iexpr '=' rexpr {
     used_code["i_EQ_i"] = 1;
     used_code["i_EQ_r"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nLDX #0\nPLA\n";
     code[progp++] = "JSR i_EQ_r\nPHA\nPHA\n";
}
| iexpr '=' iexpr {
     used_code["i_EQ_i"] = 1;
     code[progp++] = "PLA\nSTA r2h\nPLA\nSTA r2l\nPLA\nTAY\nPLA\nSTA r3h\nLDA #0\nSTA r3l\nJSR i_EQ_i\nPHA\nPHA\n";
}
| rexpr NE rexpr {
     used_code["i_NE_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nTAY\nPLA\nJSR i_NE_i\nPHA\nPHA\n";
}
| rexpr NE iexpr {
     used_code["i_NE_i"] = 1;
     code[progp++] = "PLA\nSTA r2l\nLDX #0\nPLA\nSTA r2h\nBPL *+3\nDEX\nSTX r3l\nPLA\nSTA r3h\nPLA\nTAY\n";
     code[progp++] = "PLA\nJSR i_NE_i\nPHA\nPHA\n";
}
| iexpr NE rexpr {
     used_code["i_NE_i"] = 1;
     used_code["i_NE_r"] = 1;
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nSTA r3l\nPLA\nSTA r3h\nLDX #0\nPLA\n";
     code[progp++] = "JSR i_NE_r\nPHA\nPHA\n";
}
| iexpr NE iexpr {
     used_code["i_NE_i"] = 1;
     code[progp++] = "PLA\nSTA r2h\nPLA\nSTA r2l\nPLA\nTAY\nPLA\nSTA r3h\nLDA #0\nSTA r3l\nJSR i_NE_i\nPHA\nPHA\n";
}
| iexpr AND iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nAND r2l\nTAX\nPLA\nAND r2h\nPHA\nTXA\nPHA\n";
}
| iexpr AND rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nPLA\nAND r2l\nTAX\nPLA\nAND r2h\nPHA\nTXA\nPHA\n";
}
| rexpr AND iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nAND r2l\nTAX\nPLA\nAND r2h\nTAY\nPLA\nTYA\nPHA\nTXA\nPHA\n";
}
| rexpr AND rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nPLA\nAND r2l\nTAX\nPLA\nAND r2h\nTAY\nPLA\nTYA\nPHA\nTXA\nPHA\n";
}
| iexpr OR iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nORA r2l\nTAX\nPLA\nORA r2h\nPHA\nTXA\nPHA\n";
}
| iexpr OR rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nPLA\nORA r2l\nTAX\nPLA\nORA r2h\nPHA\nTXA\nPHA\n";
}
| rexpr OR iexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nORA r2l\nTAX\nPLA\nORA r2h\nTAY\nPLA\nTYA\nPHA\nTXA\nPHA\n";
}
| rexpr OR rexpr {
     code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nPLA\nPLA\nORA r2l\nTAX\nPLA\nORA r2h\nTAY\nPLA\nTYA\nPHA\nTXA\nPHA\n";
}
| NOT iexpr {
     code[progp++] = "PLA\nEOR #$FF\nTAX\nPLA\nEOR #$FF\nPHA\nTXA\nPHA\n";
}
| NOT rexpr {
     code[progp++] = "PLA\nEOR #$FF\nTAX\nPLA\nEOR #$FF\nTAY\nPLA\nTYA\nPHA\nTXA\nPHA\n";
}
| sexpr GT sexpr {
     used_code["s_GT_s"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nJSR s_GT_s\nPHA\nPHA\n";
}
| sexpr GE sexpr {
     used_code["s_GE_s"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nJSR s_GE_s\nPHA\nPHA\n";
}
| sexpr LT sexpr {
     used_code["s_LT_s"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nJSR s_LT_s\nPHA\nPHA\n";
}
| sexpr LE sexpr {
     used_code["s_LE_s"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nJSR s_LE_s\nPHA\nPHA\n";
}
| sexpr '=' sexpr {
     used_code["s_EQ_s"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nJSR s_EQ_s\nPHA\nPHA\n";
}
| sexpr NE sexpr {
     used_code["s_NE_s"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nJSR s_EQ_s\nEOR #255\nPHA\nPHA\n";
}
| RLUM '(' iexpr ')' {
     used_code["rlum"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nJSR rlum\nPHA\nTYA\nPHA\n";
}
| RLUM '(' rexpr ')' {
     used_code["rlum"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nJSR rlum\nPHA\nTYA\nPHA\n";
}
| RCLR '(' iexpr ')' {
     used_code["rclr"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nJSR rclr\nPHA\nTYA\nPHA\n";
}
| RCLR '(' rexpr ')' {
     used_code["rclr"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nPLA\nJSR rclr\nPHA\nTYA\nPHA\n";
}
| RGR {
     used_code["rgr"] = 1;
     code[progp++] = "JSR rgr\nPHA\nTYA\nPHA\n";
}
;
fncmain: fncparams {
     if (deffn == -2)
        code[progp++] = "LDA baseptr\nPHA\nTSX\nINX\n";
     else
        code[progp++] = "TSX\n";
     code[progp++] = "INX\nSTX baseptr\nJSR __" + tostry($<sym>0->addr);
     if (deffn == -2)
        code[progp++] = "PLA\nSTA baseptr\n";
     if (callfn >= 1)
         code[progp++] = "PLA\nPLA\nPLA\n";
     code[progp++] = "LDA r2l\nPHA\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
;
fncparams: '(' e1rexpr ')' {callfn = 1;}
;
sexpr: STRINGTYPE {syntax4($1);}
| svar {
     //code[progp++] = "PLA\nSTA r2l\nPLA\nSTA r2h\nLDY #1\n";
     //code[progp++] = "LDA (r2l),Y\nPHA\nDEY\nLDA (r2l),Y\nPHA\n";
     code[progp++] = "JSR getvarval\n";
}
| LEFT '(' sexpr ',' iexpr ')' {
     used_code["midS_s_i_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nSTA r2l\nPLA\nJSR leftS_s_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| LEFT '(' sexpr ',' rexpr ')' {
     used_code["midS_s_i_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nPLA\nSTA r2l\nPLA\nJSR leftS_s_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| RIGHT '(' sexpr ',' iexpr ')' {
     used_code["midS_s_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nSTA r2l\nPLA\nJSR rightS_s_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| RIGHT '(' sexpr ',' rexpr ')' {
     used_code["midS_s_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nPLA\nSTA r2l\nPLA\nJSR rightS_s_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| MID '(' sexpr ',' iexpr ')' {
     used_code["midS_s_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nTAX\nDEX\nSTX r4l\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR midS_s_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| MID '(' sexpr ',' rexpr ')' {
     used_code["midS_s_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nTAX\nDEX\nSTX r4l\nPLA\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR midS_s_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| MID '(' sexpr ',' iexpr ',' iexpr ')' {
     used_code["midS_s_i_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nTAX\nDEX\nSTX r4l\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR midS_s_i_i\n";
     code[progp++] = "LDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| MID '(' sexpr ',' iexpr ',' rexpr ')' {
     used_code["midS_s_i_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nPLA\nTAX\nDEX\nSTX r4l\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR midS_s_i_i\n";
     code[progp++] = "LDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| MID '(' sexpr ',' rexpr ',' iexpr ')' {
     used_code["midS_s_i_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nTAX\nDEX\nSTX r4l\nPLA\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR midS_s_i_i\n";
     code[progp++] = "LDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| MID '(' sexpr ',' rexpr ',' rexpr ')' {
     used_code["midS_s_i_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nPLA\nTAX\nDEX\nSTX r4l\nPLA\nPLA\nPLA\nSTA r2l\nPLA\nSTA r2h\nJSR midS_s_i_i\n";
     code[progp++] = "LDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| STR '(' iexpr ')' {
     used_code["strS_i"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nJSR strS_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| STR '(' rexpr ')' {
     used_code["strS_i"] = 1;
     used_code["pr_real"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nTAX\nPLA\nSTA r0l\nPLA\nSTA r0h\nJSR redir\nJSR pr_real\nJSR strS_i1\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| TIs {
     used_code["div24_16"] = 1;
     used_code["div16"] = 1;
     used_code["TIs"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "JSR TIs\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| DSs {
     used_code["DSs"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "JSR DSs\nLDA strestatic-3\nPHA\nLDA strestatic-4\nPHA\n";
}
| CHR '(' iexpr ')' {
     used_code["gc"] = 1;
     used_code["exitstring"] = 1;
     used_code["chr"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nJSR chrS_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| CHR '(' rexpr ')' {
     used_code["gc"] = 1;
     used_code["exitstring"] = 1;
     used_code["chr"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nPLA\nJSR chrS_i\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| HEX '(' iexpr ')' {
     used_code["hexconv"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nJSR hexmain\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| HEX '(' rexpr ')' {
     used_code["hexconv"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\n";
     //code[progp++] = "BNE error\n";
     code[progp++] = "JSR hexmain\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| sexpr '+' sexpr {
     used_code["string"] = 1;
     used_code["gc"] = 1;
     code[progp++] = "PLA\nSTA r3l\nPLA\nSTA r3h\nPLA\nSTA r4l\nPLA\nJSR s_PLUS_s\nLDA r5h\nPHA\nLDA r5l\nPHA\n";
}
| '(' sexpr ')'
;
%%
int lineno = 1;

#include "lex.yy.c"

void syntax1(Symbol *s1) {
   int n = 0;
   if (s1->dimensions.size() == 0)
      if (dimcount == 1) {
         s1->dimensions.resize(1);
         s1->dimensions[0] = 1;
         for (map<string, Symbol>::iterator i = names.begin(); i != names.end(); ++i)
            if (i->second.type == s1->type && i->second.addr > s1->addr)
               i->second.addr += s1->type == RVAR ? 30 : 20;
         if (s1->type == SVAR)
            svarp += 20, s1->len += 20;
         else if (s1->type == IVAR)
            ivarp += 20, s1->len += 20;
         else
            rvarp += 30, s1->len += 30;
      }
      else
         throw *s1->name + " has a bad subscript";
   code[progp++] = "PLA\nSTA r4l\nPLA\nSTA r4h\n";
   while (++n < s1->dimensions.size()) {
      used_code["mul16"] = 1;
      used_code["multarray"] = 1;
      code[progp++] = "PLA\nSTA r1l\nPLA\nSTA r1h\nLDX #<" + tostry(s1->dimensions[n]) + "LDA #>" 
         + tostry(s1->dimensions[n]) + "JSR multarray\n";
   }
   if (s1->type == RVAR) {
      used_code["array3"] = 1;
      code[progp++] = "JSR array3\n";
   }
   else {
      used_code["array"] = 1;
      code[progp++] = "JSR array\n";
   }
   code[progp++] = "ADC #<";
   realloca[progp] = s1;
   code[progp++] = tostr(s1->addr);
   code[progp++] = "\nTAX\nLDA r4h\nADC #>";
   realloca[progp] = s1;
   code[progp++] = tostr(s1->addr);
   code[progp++] = "\nPHA\nTXA\nPHA\n";
}

void syntax2(Symbol *s1) {
   s1->dimensions.resize(v.size());
   s1->dimensions[0] = 1;
   for (int k = 1; k < v.size(); k++)
      s1->dimensions[k] = s1->dimensions[k - 1]*v[k - 1];
   v.clear();
}

void syntax3(Symbol *s0) {
     code[progp++] = "LDA #>";
     realloca[progp] = s0;
     code[progp++] = tostr(s0->addr);
     code[progp++] = "\nPHA\n";
     code[progp++] = "LDA #<";
     realloca[progp] = s0;
     code[progp++] = tostr(s0->addr);
     code[progp++] = "\nPHA\n";
}

void syntax4(Symbol *s1) {
     if (s1->len > 0) {
        if (s1->used == 0) {
           s1->used++;
           data1[stringp++] = ".byte " + tostr(s1->len);
           data1[stringp++] = "\n.text \"" + *s1->name + "\"\n";
        }
        code[progp++] = "LDA #>";
        reallocs[progp] = s1;
        code[progp++] = tostr(s1->addr);
        code[progp++] = "\nPHA\n";
        code[progp++] = "LDA #<";
        reallocs[progp] = s1;
        code[progp++] = tostr(s1->addr);
        code[progp++] = "\nPHA\n";
     }
     else
        code[progp++] = "LDA #>lib_end\nPHA\nLDA #<lib_end\nPHA\n";
}

void set_env() {
     used_code["array"] = 0;
     used_code["array3"] = 0;
     used_code["atn"] = 0;
     used_code["cat"] = 0;
     used_code["collect"] = 0;
     used_code["color"] = 0;
     used_code["close"] = 0;
     used_code["char"] = 0;
     used_code["chkin"] = 0;
     used_code["chr"] = 0;
     used_code["chout"] = 0;
     used_code["clrch"] = 0;
     used_code["copy"] = 0;
     used_code["div16"] = 0;
     used_code["div24_16"] = 0;
     used_code["div24"] = 0;
     used_code["DSi"] = 0;
     used_code["DSs"] = 0;
     used_code["exp"] = 0;
     used_code["gc"] = 0;
     used_code["gc_fast"] = 0;
     used_code["gc_quick"] = 1;   //=0 means Shell sort
     used_code["hex2dec"] = 0;
     used_code["hexconv"] = 0;
     used_code["getkey_I"] = 0;
     used_code["getkey_I0"] = 0;
     used_code["getkey_S"] = 0;
     used_code["input"] = 0;
     used_code["instr"] = 0;
     used_code["i_GE_i"] = 0;
     used_code["i_GE_r"] = 0;
     used_code["i_GT_i"] = 0;
     used_code["i_GT_r"] = 0;
     used_code["i_LE_i"] = 0;
     used_code["i_LE_r"] = 0;
     used_code["i_LT_i"] = 0;
     used_code["i_LT_r"] = 0;
     used_code["i_NE_i"] = 0;
     used_code["i_NE_r"] = 0;
     used_code["i_EQ_i"] = 0;
     used_code["i_EQ_r"] = 0;
     used_code["intfromdata"] = 0;
     used_code["intfromfile"] = 0;
     used_code["intfromkbd"] = 0;
     used_code["header"] = 0;
     used_code["key"] = 0;
     used_code["joy"] = 0;
     used_code["load"] = 0;
     used_code["log"] = 0;
     used_code["midS_s_i"] = 0;
     used_code["midS_s_i_i"] = 0;
     used_code["midS_s_i_s"] = 0;
     used_code["mul16"] = 0;
     used_code["mul24"] = 0;
     used_code["multarray"] = 0;
     used_code["open"] = 0;
     used_code["pexpr"] = 0;
     used_code["power24"] = 0;
     used_code["print2tab"] = 0;
     used_code["pr_real"] = 0;
     used_code["pu"] = 0;
     used_code["pudef"] = 0;
     used_code["rclr"] = 0;
     used_code["rgr"] = 0;
     used_code["rlum"] = 0;
     used_code["s_assign_se"] = 0;
     used_code["s_assign_ti"] = 0;
     used_code["s_EQ_s"] = 0;
     used_code["s_GE_s"] = 0;
     used_code["s_GT_s"] = 0;
     used_code["s_LE_s"] = 0;
     used_code["s_LT_s"] = 0;
     used_code["s_NE_s"] = 0;
     used_code["save"] = 0;
     used_code["scratch"] = 0;
     used_code["sound"] = 0;
     used_code["sqr"] = 0;
     used_code["str2dec"] = 0;
     used_code["strfromdata"] = 0;
     used_code["strfromfile"] = 0;
     used_code["strfromkbd"] = 0;
     used_code["string"] = 0;
     used_code["strS_i"] = 0;
     used_code["sys"] = 0;
     used_code["TIs"] = 0;
     used_code["verify"] = 1;
}

void load_src(FILE *fn) {
   src.size = fread(src.b, 1, SRCMAX, fn);
   src.pos = 0;
   string s(src.b), r1, r2, r = "";
   StringPiece in(s);
   RE_Options opts(PCRE_MULTILINE | PCRE_DOLLAR_ENDONLY | PCRE_DOTALL | PCRE_CASELESS);
   RE re("^(.*?)(ABS|AND|ASC|ATN|CHAR|CHR\\$|CLOSE|CLR|CMD|COLLECT|COLOR|COPY|DEC|DEF|DIM|\
DIRECTORY|DO|ELSE|END|EXIT|EXP|FN|FOR|FRE|GETKEY|GOSUB|GOTO|HEADER|HEX\\$|IF|INPUT|INSTR|\
INT|JOY|KEY|LABEL|LEFT\\$|LEN|LET|LOAD|LOCATE|LOG|LOOP|MID\\$|MONITOR|NEW|NEXT|NOT|ON|\
OPEN|OR|PEEK|PI|POKE|POS|PRINT|PUDEF|RCLR|RDOT|READ|RENAME|RESTORE|RETURN|RGR|RIGHT\\$|\
RLUM|RUN|SAVE|SCNCLR|SCRATCH|SGN|SPC|SOUND|SQR|STEP|STR\\$|SYS|TAB|THEN|TO|TRAP|UNTIL|USING|\
USR|VAL|VERIFY|VOL|WAIT|WHILE|[ \t]+|\"[^\"]*?\"|REM.*?\n|DATA.*?\n|GET)", opts);  //TI,ST,GO
   while (re.Consume(&in, &r1, &r2)) {
       r += r1;
       if (r2[0] != '"' && strncasecmp(r2.c_str(), "DATA", 4) && r2[0] != ' ' && r2[0] != '\t')
          r += " " + r2 + " ";
       else if  (r2[0] != ' ' && r2[0] != '\t')
          r += r2;
   }
   r += in.data();
   r += '\n';  //for index
   strcpy(src.b, r.c_str());
   src.size = r.length();
}

string comments() {
   int k = 0;
   string r;
   src.ocpos = src.cpos;
   for(;;) {
      do
         r += src.b[src.cpos + k];
      while (src.b[src.cpos + k++] != '\n');
      src.cpos += k;
      if (k > 2) break; else k = 0, r = "";
   }
   return r;
}

int yyerror(const string &s) {
   ostringstream oss;
   oss << s << " in " << lineno;
   throw oss.str();
}

int main (int argc, char **argv) {
   if (argc != 2) {
      cout << "Reduced Basic cross-compiler with Italian flavor for Commodore Basic 3.5 v0.04 (C) 2016, 2017, 2024 GNU GPL\n";
      cout << "USAGE: rcbccwif INFILE >OUTFILE\n";
      return 0;
   }
   FILE *fn = fopen(argv[1], "r");
   if (fn == 0) {
      cerr << "cannot open file " << argv[1] << endl;
      return 1;
   }
   //yydebug = 1;
   set_env();
   load_src(fn);
   fclose(fn);
   try {
      initcode();
      yyparse();
   }
   catch (string s) {
      src.cpos = src.ocpos;
      cerr << "\nERROR: " << s << endl << comments();
      return 1;
   }
   relocate(); 
   printcode();
   printsymb();
   return 0;
}

