#include <fstream>
#include "cbm35basic.h"
#include "y.tab.h"
#define progstart 0x1001

int progp, ivarp, svarp, rvarp, strconstp, stringp, locals, comm_on = 1, optimizer_on = 1;

void initcode() {
}

string tostr(int i) {
   ostringstream ostr;
   ostr << i;
   return ostr.str();
}

string tostry(int i) {
   ostringstream ostr;
   ostr << i << "\n";
   return ostr.str();
}

int toint(string s) {
   int i;
   istringstream istr(s);
   istr >> i;
   return i;
}

void printcode() {
   ostringstream ostr;
   string wholecode;
   ostr << ".include \"cbm35basic.mac\"\n";
   int strsize = svarp + 2 + 2*used_code["DSs"];
   if (strsize > 140 && used_code["gc"]) used_code["gc_fast"] = 1;
   for (map<string,int>::iterator i = used_code.begin(); i != used_code.end(); i++)
      ostr << "opt_" << i->first << " = " << i->second << '\n';
   ostr << "* = $" << hex << progstart << dec << endl;
   ostr << ".byte $b,$10,$a,0,$9e,$34,$31,$30,$39,0,0,0\n";
   ostr << "LDX #255\nTXS\n";
   ostr << "LDA #<bintr\nSTA $FFFE\nLDA #>bintr\nSTA $FFFF\nSTA $FF3F\n";
   ostr << "progstart0 JSR clr\n";
   ostr << "JMP progstart\n";
   ostr << "postload sta $ff3f\n";
   ostr << "BCC progstart0+3\n";
   ostr << "traphandle LDX #255\nTXS\n";
   ostr << "traphandle0 JMP default_rte\n";
   ostr << "bintr STA $FF3E\nSTA *+11\nLDA #>rintr\nPHA\nLDA #<rintr\nPHA\nPHP\nLDA #0\n";
   ostr << "PHA\nTXA\nPHA\nTYA\nPHA\nJMP ($314)\n";
   ostr << "rintr STA $FF3F\nRTI\n";
   ostr << "coutROM STA $FF3E\nJSR cout\ncoutROM0 STA $FF3F\nRTS\n";
   ostr << "ROMcall STA $FF3E\nJSR ROMjump\nSTA $FF3F\nRTS\nROMjump JMP (r5l)\n";
   ostr << ".include \"plus4.mac\"\n.include \"cbm35basic.inc\"\nprogstart\n";
   for (int i = 0; i < progp; i++)
      ostr << code[i];
   ostr << "JMP finalfinish\n";
   ostr << "lib_end\n";
   ostr << ".byte 0\n";
   for (int i = 0; i < stringp; i++)
      ostr << data1[i];
   ostr << "datastart\n";
   for (int k = 0; k < datalines_count; k++) {
      ostr << ".byte " << datalines[k].length() << endl;
      if (datalines[k].length())
         ostr << ".text \"" << datalines[k] << "\"\n";
   }
   if (used_code["gc_fast"]) {
      if (used_code["gc_quick"]) ostr << "* = (* + 1) & $fffe\n";
      ostr << "strsgc\n";
      //ostr << ".block\ncnt .var " << strsize/2
      //       << "\nlloop .lbl\ncnt .var cnt-1\n.word strsstatic+cnt*2\n.ifne cnt\n.goto lloop\n.endif\n.bend\n";
      for (int k = 0; k < strsize/2; k++)
          ostr << ".word strsstatic+" << k*2 << endl;
      ostr << "gc_sz2 = " << strsize << endl;
      if (!used_code["gc_quick"]) {
           int shellsort_gaps[] = {2, 8, 20, 46, 114, 264, 602, 1402, 3500, 4759*2, 12923*2}; //;this sequence
                             //must be the same as in gc2.s!
           int dg = 0;
           for(int i = 1; i < sizeof(shellsort_gaps)/sizeof(int); i++)
               if (shellsort_gaps[dg] < strsize) dg = i;
           ostr << "gc_start_k2 = " << dg*2 << endl;
      }
   }
   ostr << "strsstatic\n";
   ostr << "strestatic = " << strsize << " + strsstatic\n";
   ostr << "strsdyn = " << strsize + ivarp + rvarp << " + strsstatic\n";
   wholecode = ostr.str();
   optimizer(wholecode);
   cout << wholecode;
}

void relocate() {
   for (map<int,int>::iterator i = dataprogp.begin(); i != dataprogp.end(); i++)
      code[i->first] = "LDA #<datastart+" + tostr(datalabels[i->second]) + "\nSTA datapos\nLDA #>datastart+"
           + tostr(datalabels[i->second]) + "\n STA datapos+1\n";
   for (map<int,int>::iterator i = reallocl.begin(); i != reallocl.end(); i++)
      code[i->first] = "__" + tostr(labels[i->second]) + "\n";
   for (map<int,Symbol*>::iterator i = reallocs.begin(); i != reallocs.end(); i++)
      code[i->first] = tostr(i->second->addr + 1)  + "+lib_end";
   for (map<int,Symbol*>::iterator i = realloca.begin(); i != realloca.end(); i++)
      if (i->second->type == IVAR)
         code[i->first] = tostr(i->second->addr) + "+strestatic";
   for (map<int,Symbol*>::iterator i = realloca.begin(); i != realloca.end(); i++)
      if (i->second->type == RVAR)
         code[i->first] = tostr(i->second->addr + ivarp) + "+strestatic";
   for (map<int,Symbol*>::iterator i = realloca.begin(); i != realloca.end(); i++)
      if (i->second->type == SVAR)
         code[i->first] = tostr(i->second->addr) + "+strsstatic";
}

void printsymb() {
   cout << ";integer variables:\n";
   for (map<string, Symbol>::iterator p = names.begin(); p != names.end(); p++) 
      if (p->second.type == IVAR) cout << ";  " << p->first << '\t' << p->second.len
         << '\t' << p->second.addr << endl;
   cout << ";real variables:\n";
   for (map<string, Symbol>::iterator p = names.begin(); p != names.end(); p++)
      if (p->second.type == RVAR) cout << ";  " << p->first << '\t' << p->second.len
         << '\t' << p->second.addr << endl;
   cout << ";string variables:\n";
   for (map<string, Symbol>::iterator p = names.begin(); p != names.end(); p++)
      if (p->second.type == SVAR) cout << ";  " << p->first << '\t' << p->second.len
         << '\t' << p->second.addr << endl;
   cout << ";functions:\n";
   for (map<string, Symbol>::iterator p = names.begin(); p != names.end(); p++)
      if (p->second.type == FVAR) cout << ";  " << p->first << '\t' << p->second.len << endl;
}

void breakpoint() {
}

void optimizer(string &code) {
    if (!optimizer_on) return;
    RE_Options opts(PCRE_MULTILINE | PCRE_DOLLAR_ENDONLY | PCRE_DOTALL);
    int count = 0, lcount;
    //RE("TAX\n", opts).GlobalReplace("STA X\n", &code);
    //RE("TXA\n", opts).GlobalReplace("LDA X\n", &code);
    //RE("TAY\n", opts).GlobalReplace("STA Y\n", &code);
    //RE("TYA\n", opts).GlobalReplace("LDA Y\n", &code);
    string
       LDAi = "LDA #([^\n]+)\n",
       LDAa = "LDA([^\n]+)\n",
       STAa = "STA([^\n]+)\n",
       PLA = "PLA\n",
       PHA = "PHA\n";
    do {
       lcount = 0;
       lcount += RE(LDAi + PHA + LDAi + STAa + PLA, opts).GlobalReplace("LDA #\\2\nSTA\\3\nLDA #\\1\n", &code);
       lcount += RE(LDAi + PHA + LDAi + PHA + LDAi + PHA + LDAi + PHA + LDAi + PHA + "((LDA #([^\n]+)\nSTA([^\n]+)\n){2})" + PLA + "TAX\n" + PLA + PLA + "TAY\n" + PLA + PLA, opts).GlobalReplace("\\6LDY #\\3\nLDX #\\5\nLDA #\\1\n", &code);
       lcount += RE(LDAi + PHA + LDAi + PHA + "((LDA #([^\n]+)\nSTA([^\n]+)\n){2})" + PLA + STAa + PLA, opts)
            .GlobalReplace("\\3LDA #\\2\nSTA\\7\nLDA #\\1\n", &code);
       lcount += RE(LDAi + PHA + LDAi + PHA + LDAi + PHA + "(LDA #([^\n]+)\nTAX\n)PLA\nSTA([^\n]+)\n" + PLA + STAa + PLA, opts).GlobalReplace("\\4LDA #\\3\nSTA\\6\nLDA #\\2\nSTA\\7\nLDA #\\1\n", &code);
       lcount += RE(LDAi + PHA + LDAi + STAa + PLA, opts).GlobalReplace("LDA #\\2\nSTA\\3\nLDA #\\1\n", &code);
       lcount += RE(LDAi + PHA + LDAi + "TAX\n" + PLA + "TXA\n", opts).GlobalReplace("LDA #\\2\n", &code);
       lcount += RE(LDAa + PHA + "(LDA([^\n]+)\nSTA([^\n]+)\n)" + PLA, opts).GlobalReplace("\\2LDA\\1\n", &code);
       lcount += RE(LDAa + PHA + "(LDA([^\n]+)\nSTA([^\n]+)\n)" + PLA, opts).GlobalReplace("\\2LDA\\1\n", &code);
       lcount += RE(LDAa + PHA + "(LDA([^\n]+)\nTAX\n)" + PLA, opts).GlobalReplace("\\2LDA\\1\n", &code);
       lcount += RE("PHA\nTXA\nSTA([^()\n]+)\nPLA", opts).GlobalReplace("STX\\1", &code);
       lcount += RE("PHA\nTXA\nTAX\nPLA\n", opts).GlobalReplace("", &code);
       lcount += RE("PHA\nTXA\nTAX\nPLA\n", opts).GlobalReplace("", &code);
       lcount += RE("LDA([^()\n]+)\nTAX\nPLA", opts).GlobalReplace("LDX\\1\nPLA", &code);
       lcount += RE(PHA + "(LD[XY][^\n]+|TAY|TAX)\nPLA", opts).GlobalReplace("\\1", &code);
       lcount += RE("PHA\nSTA([^\n]+)\nPLA", opts).GlobalReplace("STA\\1", &code);
       lcount += RE("PHA\nPLA\n", opts).GlobalReplace("", &code);
       lcount += RE(LDAi + PLA, opts).GlobalReplace(PLA, &code);
       //lcount += RE(LDAi + "TAX\n", opts).GlobalReplace("LDX #\\1\n", &code);  //test this! must be in the 2nd stage
       count += lcount;
    } while (lcount > 0);
    //RE("STA X\n", opts).GlobalReplace("TAX\n", &code);
    //RE("LDA X\n", opts).GlobalReplace("TXA\n", &code);
    //RE("STA Y\n", opts).GlobalReplace("TAY\n", &code);
    //RE("LDA Y\n", opts).GlobalReplace("TYA\n", &code);
    cerr << count << " optimizations\n";
}

void lexre(string& istr) {
     ostringstream oss;
     RE_Options opts(PCRE_CASELESS | PCRE_EXTRA);
     char s[2] = {0, 0};
     for (int i = 1; i < 256; i++) {
        s[0] = i;
        oss << "{\\$0?" << hex << i << "}";
        RE(oss.str(), opts).GlobalReplace(s, &istr);
        oss.str("");
     }
     for (int i = 1; i < 256; i++) {
        s[0] = i;
        oss << "\\{" << dec << i << "\\}";
        RE(oss.str(), opts).GlobalReplace(s, &istr);
        oss.str("");
     }
     for (int i = 0; i < 26; i++) {
        s[0] = i + 1;
        oss << "{CTRL-" << (char)('@' + s[0]) << "}";
        RE(oss.str(), opts).GlobalReplace(s, &istr);
        oss.str("");
     }
     {
		 int x;
		 string z;
		 while (RE("({space\\*([0-9]+)})", opts).PartialMatch(istr, &z, &x))
		     RE(RE::QuoteMeta(z)).GlobalReplace(string(x, ' '), &istr);
     }
     for (int i = 1; i < 256; i++) {
		 int x;
		 string z;
		 oss << "({" << dec << i << "\\*([0-9]+)})";
		 while (RE(oss.str(), opts).PartialMatch(istr, &z, &x))
		     RE(RE::QuoteMeta(z)).GlobalReplace(string(x, i), &istr);
		 oss.str("");
     }
     //opts.set_caseless(0).set_extra(1);
     RE("{stop}", opts).GlobalReplace((s[0] = 3, s), &istr);
     RE("{wht}", opts).GlobalReplace((s[0] = 5, s), &istr);
     RE("{dish}", opts).GlobalReplace((s[0] = 8, s), &istr);
     RE("{ensh}", opts).GlobalReplace((s[0] = 9, s), &istr);
     RE("{swlc}", opts).GlobalReplace((s[0] = 14, s), &istr);
     RE("{down}", opts).GlobalReplace((s[0] = 17, s), &istr);
     RE("{rvon}", opts).GlobalReplace((s[0] = 18, s), &istr);
     RE("{home}", opts).GlobalReplace((s[0] = 19, s), &istr);
     RE("{del}", opts).GlobalReplace((s[0] = 20, s), &istr);
     RE("{esc}", opts).GlobalReplace((s[0] = 27, s), &istr);
     RE("{red}", opts).GlobalReplace((s[0] = 28, s), &istr);
     RE("{rght}", opts).GlobalReplace((s[0] = 29, s), &istr);
     RE("{grn}", opts).GlobalReplace((s[0] = 30, s), &istr);
     RE("{blu}", opts).GlobalReplace((s[0] = 31, s), &istr);//petcat
     RE("{dblu}", opts).GlobalReplace((s[0] = 31, s), &istr);//C+4
     RE("{space}", opts).GlobalReplace((s[0] = 32, s), &istr);
     RE("{orng}", opts).GlobalReplace((s[0] = 129, s), &istr);
     RE("{flon}", opts).GlobalReplace((s[0] = 130, s), &istr);//C+4
     RE("{flof}", opts).GlobalReplace((s[0] = 132, s), &istr);//C+4
     RE("{F1}", opts).GlobalReplace((s[0] = 133, s), &istr);
     RE("{F3}", opts).GlobalReplace((s[0] = 134, s), &istr);
     RE("{F5}", opts).GlobalReplace((s[0] = 135, s), &istr);
     RE("{F7}", opts).GlobalReplace((s[0] = 136, s), &istr);
     RE("{F2}", opts).GlobalReplace((s[0] = 137, s), &istr);
     RE("{F4}", opts).GlobalReplace((s[0] = 138, s), &istr);
     RE("{F6}", opts).GlobalReplace((s[0] = 139, s), &istr);
     RE("{F8}", opts).GlobalReplace((s[0] = 140, s), &istr);
     RE("{help}", opts).GlobalReplace((s[0] = 140, s), &istr);//C+4
     RE("{sret}", opts).GlobalReplace((s[0] = 141, s), &istr);
     RE("{swuc}", opts).GlobalReplace((s[0] = 142, s), &istr);
     RE("{blk}", opts).GlobalReplace((s[0] = 144, s), &istr);
     RE("{up}", opts).GlobalReplace((s[0] = 145, s), &istr);
     RE("{rvof}", opts).GlobalReplace((s[0] = 146, s), &istr);
     RE("{clr}", opts).GlobalReplace((s[0] = 147, s), &istr);
     RE("{inst}", opts).GlobalReplace((s[0] = 148, s), &istr);
     RE("{brn}", opts).GlobalReplace((s[0] = 149, s), &istr);
     RE("{lred}", opts).GlobalReplace((s[0] = 150, s), &istr);
     RE("{gry1}", opts).GlobalReplace((s[0] = 151, s), &istr);
     RE("{pink}", opts).GlobalReplace((s[0] = 151, s), &istr);//C+4
     RE("{gry2}", opts).GlobalReplace((s[0] = 152, s), &istr);
     RE("{blgn", opts).GlobalReplace((s[0] = 152, s), &istr);//C+4
     RE("{lgrn}", opts).GlobalReplace((s[0] = 153, s), &istr);
     RE("{lblu}", opts).GlobalReplace((s[0] = 153, s), &istr);
     RE("{lblu4}", opts).GlobalReplace((s[0] = 153, s), &istr);//C+4
     RE("{blu}", opts).GlobalReplace((s[0] = 154, s), &istr);
     RE("{blu4}", opts).GlobalReplace((s[0] = 154, s), &istr);//C+4
     RE("{gry3}", opts).GlobalReplace((s[0] = 155, s), &istr);
     RE("{lgrn}", opts).GlobalReplace((s[0] = 155, s), &istr);
     RE("{lgrn4}", opts).GlobalReplace((s[0] = 155, s), &istr);//C+4
     RE("{pur}", opts).GlobalReplace((s[0] = 156, s), &istr);
     RE("{left}", opts).GlobalReplace((s[0] = 157, s), &istr);
     RE("{yel}", opts).GlobalReplace((s[0] = 158, s), &istr);
     RE("{cyn}", opts).GlobalReplace((s[0] = 159, s), &istr);
     RE("{CBM-K}", opts).GlobalReplace((s[0] = 161, s), &istr);
     RE("{CBM-I}", opts).GlobalReplace((s[0] = 162, s), &istr);
     RE("{CBM-T}", opts).GlobalReplace((s[0] = 163, s), &istr);
     RE("{CBM-@}", opts).GlobalReplace((s[0] = 164, s), &istr);
     RE("{CBM-G}", opts).GlobalReplace((s[0] = 165, s), &istr);
     RE("{CBM-\\+}", opts).GlobalReplace((s[0] = 166, s), &istr);
     RE("{CBM-M}", opts).GlobalReplace((s[0] = 167, s), &istr);
     RE("{CBM-POUND}", opts).GlobalReplace((s[0] = 168, s), &istr);
     RE("{SHIFT-POUND}", opts).GlobalReplace((s[0] = 169, s), &istr);
     RE("{CBM-N}", opts).GlobalReplace((s[0] = 170, s), &istr);
     RE("{CBM-Q}", opts).GlobalReplace((s[0] = 171, s), &istr);
     RE("{CBM-D}", opts).GlobalReplace((s[0] = 172, s), &istr);
     RE("{CBM-Z}", opts).GlobalReplace((s[0] = 173, s), &istr);
     RE("{CBM-S}", opts).GlobalReplace((s[0] = 174, s), &istr);
     RE("{CBM-P}", opts).GlobalReplace((s[0] = 175, s), &istr);
     RE("{CBM-A}", opts).GlobalReplace((s[0] = 176, s), &istr);
     RE("{CBM-E}", opts).GlobalReplace((s[0] = 177, s), &istr);
     RE("{CBM-R}", opts).GlobalReplace((s[0] = 178, s), &istr);
     RE("{CBM-W}", opts).GlobalReplace((s[0] = 179, s), &istr);
     RE("{CBM-H}", opts).GlobalReplace((s[0] = 180, s), &istr);
     RE("{CBM-J}", opts).GlobalReplace((s[0] = 181, s), &istr);
     RE("{CBM-L}", opts).GlobalReplace((s[0] = 182, s), &istr);
     RE("{CBM-Y}", opts).GlobalReplace((s[0] = 183, s), &istr);
     RE("{CBM-U}", opts).GlobalReplace((s[0] = 184, s), &istr);
     RE("{CBM-O}", opts).GlobalReplace((s[0] = 185, s), &istr);
     RE("{SHIFT-@}", opts).GlobalReplace((s[0] = 186, s), &istr);
     RE("{CBM-F}", opts).GlobalReplace((s[0] = 187, s), &istr);
     RE("{CBM-C}", opts).GlobalReplace((s[0] = 188, s), &istr);
     RE("{CBM-X}", opts).GlobalReplace((s[0] = 189, s), &istr);
     RE("{CBM-V}", opts).GlobalReplace((s[0] = 190, s), &istr);
     RE("{CBM-B}", opts).GlobalReplace((s[0] = 191, s), &istr);
     RE("{SHIFT-\\*}", opts).GlobalReplace((s[0] = 192, s), &istr);
     RE("{SHIFT-\\+}", opts).GlobalReplace((s[0] = 219, s), &istr);
     RE("{CBM--}", opts).GlobalReplace((s[0] = 220, s), &istr);
     RE("{SHIFT--}", opts).GlobalReplace((s[0] = 221, s), &istr);
     RE("{CBM-\\*}", opts).GlobalReplace((s[0] = 223, s), &istr);
}

